/* lists.h
 *
 * Exec list support
 *
 * Copyright (c) 1993 by Ezra Story.  All rights reserved.  Permission to
 * copy this program is given provided that the copy is not sold and that
 * this copyright notice is included.
 * $Id: lists.h 1.1 1994/06/06 22:02:14 Ezra_Story Exp $
 */

typedef struct Node
{
    struct Node *Succ;      /* Pointer to next (successor) */
    struct Node *Pred;      /* Pointer to previous (predecessor) */
    char Pri;       /* Priority, for sorting */
} NODE;

typedef struct List
{
   NODE *Head;
   NODE *Tail;
   NODE *TailPred;
} LIST;

#define IsListEmpty(x) ( ((x)->TailPred) == (NODE *)(x) )

extern NewList();
extern AddTail();
extern AddHead();
extern Insert();
extern NODE *RemTail();
extern NODE *RemHead();
extern Remove();
extern Enqueue();

