/*
 *
 *  AM --- AmigaMail
 *  (C) 1991, 1992 by Christian Riede
 *
 *  AM is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY.  No author or distributor accepts responsibility to anyone
 *  for the consequences of using it or for whether it serves any
 *  particular purpose or works at all, unless he says so in writing.
 *  Refer to the GNU General Public License, Version 1, for full details.
 *  
 *  Everyone is granted permission to copy, modify and redistribute AM,
 *  but only under the conditions described in the GNU General Public
 *  License, Version 1.  A copy of this license is supposed to have been 
 *  given to you along with AM so you can know your rights and responsi-
 *  bilities.  It should be in a file named COPYING.  Among other things,
 *  the copyright notice and this notice must be preserved on all copies.
 *
 *  
 *
 */

#include "am.h"

int ix_exec_entry (int argc, char **argv, char **environ, int *real_errno,
	int (*main)(int, char **, char **));

static void DisplayMail(char *s)
{
	char cmd[200];

	sprintf(cmd,"%s %s",RFilter,s);
	system(cmd);
}


static void CallMetamail (char *Mailname)
{
    char TmpFileName[200];
    char Cmd[200];
	char MsgId[80];
	struct TagItem ReadSystemTags[]={
		{SYS_Input,0},
		{SYS_Output,0},
		{NP_StackSize,50000},
		{TAG_END,0}
	};
	BPTR tmpfile;

	sprintf(TmpFileName,"t:%s",NewMsgId(MsgId));
    sprintf(Cmd,"%s -r -x -d %s",METAMAIL,Mailname);
	if (tmpfile = Open((UBYTE *)TmpFileName,MODE_NEWFILE))
	{
		ReadSystemTags[1].ti_Data = tmpfile;
		System((UBYTE *)Cmd,ReadSystemTags);
		Close(tmpfile);
	}

	DisplayMail(TmpFileName);

	DeleteFile((UBYTE *)TmpFileName);
}

static int notplain(char *s)
{
    char *t;
    if (!s) return(1);
    while (*s && isspace(*s)) ++s;
    for(t=s; *t; ++t) if (isupper(*t)) *t = tolower(*t);
    while (t > s && isspace(*--t)) {;}
    if (((t-s) == 3) && !strncmp(s, "text", 4)) return(0);
    if (strncmp(s, "text/plain", 10)) return(1);
    t = (char *) index(s, ';');
    while (t) {
        ++t;
        while (*t && isspace(*t)) ++t;
        if (!strncmp(t, "charset", 7)) {
            s = (char *) index(t, '=');
            if (s) {
                ++s;
                while (*s && isspace(*s)) ++s;
                if (!strncmp(s, "us-ascii", 8)) return(0);
                if (!strncmp(s, "iso-8859-1", 8)) return(0);
            }
            return(1);
        }
        t = (char *) index(t, ';');
    }
    return(0); /* no charset, was text/plain */
}


static int TheReadMail(int argc,char **argv,char **environ)
{
	FILE *fp;
	char line[1000], *s, *t, Query[200];
	int done=FALSE;

    if (fp=fopen(argv[1], "r")) 
	{
		while (fgets(line, sizeof(line), fp)) 
		{
			/* end of header? */
		    if (line[0] == '\n') break; 

			/* to lower */
		    for (s=line; *s; ++s) if (isupper(*s)) *s = tolower(*s);

			/* content-type? */
		    if (!strncmp(line, "content-type:", 13)) 
			{
				s = &line[13];
				while (*s && isspace(*s)) ++s;
				t = index(s, ';');
				if (t) 
				{
				    *t = (char) NULL;
				} 
				else 
				{
				    t = index(s, '\n');
				    if (t) *t = (char) NULL;
				}
				if (t--) 
				    while (isspace(*t) && (t > s)) 
						*t-- = (char) NULL;
				if (notplain(s)) 
				{
				    if (getenv("MM_NOASK")) 
						CallMetamail(argv[1]);
			    	else
					{
					    sprintf(Query, "This message is in %s format.\nDo you want to try to run an external interpreter?", s);
						if (TwoGadRequest(Window,Query))
						{
							CallMetamail(argv[1]);
							done=TRUE;
						}
			    	}
			    	break;
				}
		    }
		    if (!strncmp(line, "content-transfer-encoding:", 26))
			{
				s = &line[26];
				while (*s && isspace(*s)) ++s;

				if (strncmp(s,"8bit",4) && 
					strncmp(s,"7bit",4) && 
					strncmp(s,"binary",6)) /* mail is encoded */
		
				{
				    if (getenv("MM_NOASK")) 
						CallMetamail(argv[1]);
			    	else
					{
					    sprintf(Query, "This message is %s encoded.\nDo you want to try to run an external interpreter?", s);
						if (TwoGadRequest(Window,Query))
						{
							CallMetamail(argv[1]);
							done=TRUE;
						}
			    	}
			    	break;
				}
			}
 
		}
		fclose(fp);
	}

	if (!done)
		DisplayMail(argv[1]);

	return(0);
}




void ReadMail(void)
{
	register char *arg __asm__ ("a0");
	char *thearg;
	char *argv[2];
	void *ixb;

	thearg = arg; /* a0 is scratch register */

	if (!(ixb  = OpenLibrary ((UBYTE *)"ixemul.library", IX_VERSION)))
		return;

	argv[0] = "AM_ReadMail";
	argv[1] = thearg;

	ix_exec_entry(2,argv,0,0,TheReadMail);

	CloseLibrary(ixb);
}
