/*
 *
 *  AM --- AmigaMail
 *  (C) 1991, 1992 by Christian Riede
 *
 *  AM is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY.  No author or distributor accepts responsibility to anyone
 *  for the consequences of using it or for whether it serves any
 *  particular purpose or works at all, unless he says so in writing.
 *  Refer to the GNU General Public License, Version 1, for full details.
 *  
 *  Everyone is granted permission to copy, modify and redistribute AM,
 *  but only under the conditions described in the GNU General Public
 *  License, Version 1.  A copy of this license is supposed to have been 
 *  given to you along with AM so you can know your rights and responsi-
 *  bilities.  It should be in a file named COPYING.  Among other things,
 *  the copyright notice and this notice must be preserved on all copies.
 *
 *  
 *
 */

#include "am.h"

#define REQ_WIDTH 400
#define REQ_HEIGHT 100

#define OK 1
#define CANCEL 2
#define ANSWER 3

/* reentrant */
int RequestString(char *Question,char *Answer,int Len)
{
	int ok,run;
	struct IntuiMessage *Msg;
	ULONG Class;
	ULONG Code;
	APTR IAddr;
	char *saveanswer;
	struct Window *ReqWindow;
	struct Gadget *GList,*gad,*StringGadget;

	/* we need a copy of the global TextAttr for the gadets */
	static struct TextAttr RSTextAttr;

	struct NewGadget OKGadget = 
	{
		0,0,0,0,
		(UBYTE *)"OK",&RSTextAttr,
		OK,
		PLACETEXT_IN,
		0,	
		0
	};
	
	struct NewGadget CANCELGadget = 
	{
		0,0,0,0,
		(UBYTE *)"CANCEL",&RSTextAttr,
		CANCEL,
		PLACETEXT_IN,
		0,	
		0
	};
	
	struct NewGadget AnswerGadget = 
	{
		0,0,0,0,
		0,&RSTextAttr,
		ANSWER,
		PLACETEXT_ABOVE,
		0,	
		0
	};

	RSTextAttr = TextAttr;

	if (!(saveanswer = AllocMem(strlen(Answer)+1,MEMF_CLEAR)))
		return(FALSE);

	strcpy(saveanswer,Answer);

	if (Screen) /* custom screen requested */
	{
		if (!(ReqWindow = OpenWindowTags(0,
			WA_CustomScreen,Screen,
			WA_Left,Screen->Width/2-REQ_WIDTH/2,
			WA_Top,Screen->Height/2-REQ_HEIGHT/2,
			WA_Width,REQ_WIDTH,
			WA_Height,REQ_HEIGHT,
			WA_MinWidth,640L,
			WA_MinHeight,180L,
			WA_MaxWidth,1024L,
			WA_MaxHeight,1024L,
			WA_DragBar,TRUE,
			WA_DepthGadget,TRUE,
			WA_Activate,TRUE,
			WA_SmartRefresh,TRUE,
			WA_GimmeZeroZero,TRUE,
			TAG_END)))
		{
			SimpleRequest(Window,"Can't open Request-Window");
			return(FALSE);
		}
	}
	else if (PubScreen) /* public screen requested */
	{
		if (!(ReqWindow = OpenWindowTags(0,
			WA_PubScreen,(UBYTE *)PubScreen,
			WA_Left,PubScreen->Width/2-REQ_WIDTH/2,
			WA_Top,PubScreen->Height/2-REQ_HEIGHT/2,
			WA_Width,REQ_WIDTH,
			WA_Height,REQ_HEIGHT,
			WA_MinWidth,640L,
			WA_MinHeight,180L,
			WA_MaxWidth,1024L,
			WA_MaxHeight,1024L,
			WA_DragBar,TRUE,
			WA_DepthGadget,TRUE,
			WA_Activate,TRUE,
			WA_SmartRefresh,TRUE,
			WA_GimmeZeroZero,TRUE,
			TAG_END)))
		{
			SimpleRequest(Window,"Can't open Request-Window");
			return(FALSE);
		}
	}
	else
	{
		FreeMem(saveanswer,strlen(saveanswer)+1);
		return(FALSE);
	}
		
	/* adjust gadgets to window dimensions */
	OKGadget.ng_LeftEdge = 5;
	OKGadget.ng_TopEdge = ReqWindow->GZZHeight-RSTextAttr.ta_YSize-8;
	OKGadget.ng_Width = 100;                           /* !!!!!!!!!!!!!!! */
	OKGadget.ng_Height = RSTextAttr.ta_YSize+4;

	CANCELGadget.ng_LeftEdge = ReqWindow->GZZWidth-OKGadget.ng_Width-5;
	CANCELGadget.ng_TopEdge = OKGadget.ng_TopEdge;
	CANCELGadget.ng_Width = OKGadget.ng_Width;
	CANCELGadget.ng_Height = OKGadget.ng_Height;

	AnswerGadget.ng_LeftEdge = 5;
	AnswerGadget.ng_TopEdge = RSTextAttr.ta_YSize+15;
	AnswerGadget.ng_Width = ReqWindow->GZZWidth-10;
	AnswerGadget.ng_Height = RSTextAttr.ta_YSize+4;

	AnswerGadget.ng_GadgetText = (UBYTE *)Question;

	/* get visualinfo */
	if(!(OKGadget.ng_VisualInfo = GetVisualInfo(ReqWindow->WScreen,TAG_END)))
	{
		SimpleRequest(Window,"Can't get visual info");
		CloseWindow(ReqWindow);
		return(FALSE);;
	}

	CANCELGadget.ng_VisualInfo = OKGadget.ng_VisualInfo;
	AnswerGadget.ng_VisualInfo = OKGadget.ng_VisualInfo;
	
	/* allocate context */
	if (!(gad = CreateContext(&GList)))
	{
			CloseWindow(ReqWindow);
			SimpleRequest(Window,"Can't create context");
			return(FALSE);
	}

	/* create OK gadget */
	if(!(gad = CreateGadget(BUTTON_KIND,gad,&OKGadget,
		GA_RELVERIFY,TRUE,
		TAG_END)))
	{
			FreeGadgets(GList);
			CloseWindow(ReqWindow);
			SimpleRequest(Window,"Can't create ok gadget");
			return(FALSE);
	}


	/* create CANCEL gadget */
	if(!(gad = CreateGadget(BUTTON_KIND,gad,&CANCELGadget,
		GA_RELVERIFY,TRUE,
		TAG_END)))
	{
			FreeGadgets(GList);
			CloseWindow(ReqWindow);
			SimpleRequest(Window,"Can't create cancel gadget");
			return(FALSE);
	}

	/* get StringGadget */
	if (!(StringGadget = gad = CreateGadget(STRING_KIND,gad,&AnswerGadget,
		GTST_MaxChars,Len,
		GTST_String,Answer,
		TAG_END)))
	{
			FreeGadgets(GList);
			CloseWindow(ReqWindow);
			SimpleRequest(Window,"Can't create String gadget");
			return(FALSE);
	}

	/* show up gadgets */
	AddGList(ReqWindow,GList,-1,-1,NULL);
	RefreshGList(GList,ReqWindow,NULL,-1);
	GT_RefreshWindow(ReqWindow,0);

	ActivateGadget(StringGadget,ReqWindow,0);

	ModifyIDCMP(ReqWindow,GADGETUP|LISTVIEWIDCMP);

	run = TRUE;
	while (run)
	{
		Wait(1L<<ReqWindow->UserPort->mp_SigBit);
		while (Msg = GT_GetIMsg(ReqWindow->UserPort))
		{
			/* remember values */
			Class = Msg->Class;
			Code  = Msg->Code;	
			IAddr = Msg->IAddress;

			/* replay message */
			GT_ReplyIMsg(Msg);

			/* dispatch */
			switch(Class)
			{
				case REFRESHWINDOW:
					GT_BeginRefresh(ReqWindow);
					GT_EndRefresh(ReqWindow,TRUE);
					break;
				case GADGETUP:
					switch(((struct Gadget *)IAddr)->GadgetID)
					{
						case CANCEL:
							strcpy(Answer,saveanswer);
							run = FALSE;
							ok = FALSE;
							break;
						case OK:
							strcpy(Answer,(char *)((struct StringInfo *)StringGadget->SpecialInfo)->Buffer);
							run = FALSE;
							ok = TRUE;
							break;
						case ANSWER:
							break;
						default:
							puts("unknown gadget");
					}
				case MOUSEBUTTONS:
					break;
				case INTUITICKS:
					break;
				default:
					printf("Unknkown IntuiMessage->Class:%x\n",Class);
					break;
			}
		}
	}

	/* remove,free gadgets */
	RemoveGList(ReqWindow,GList,-1); 
	FreeGadgets(GList);
	FreeVisualInfo(OKGadget.ng_VisualInfo);

	CloseWindow(ReqWindow);

	return(ok);
}
