/*****************************************************************************
 * Arn                    the newsreader for UUCP-Newsgroups for the AMIGA   *
 * Version 1.xx                                         Created Arn: 30.1.90 *
 *                   (C)opyright by Roland Bless 1990-93                     *
 *                       -- ALL RIGHTS RESERVED! --                          *
 *                       A Blessed Software Product                          *
 * No redistribution of a changed source without permission of the author!   *
 * Write to: Roland Bless                                                    *
 *           Grtzinger Strasse 44                                           *
 *           D-76227 Karlsruhe (FRG)                                         *
 * or: Roland Bless, Mrsenbroicher Weg 151, FRG- 40470 Dsseldorf           *
 *                                                                           *
 * Written/Compilable under SAS/C 6.3                                        *
 * Includes: enums.h, includes.h, globalvars.h                               *
 * Modules: Arn.c, Arnhelp.c, ArnIO.c, choosegroups.c, cmdline.c, dirfunc.c, *
 * (ext.c), followup.c, functions.c, (getconfig.c), globalvars.c, grouplist.c*
 * (includes.c), kill.c, pager.c, readgroup.c, reply.c, strprocs.c, time.c,  *
 * version.c, mimesupport.c, mimedecode.c                                    *
 *                                                                           *
 * (modules) are not linked and just contain something like #include <gaga.h>*
 *                                                                           *
 *****************************************************************************/

                        /* includes and defines */
#include <stdio.h>
#include <dos.h>

#ifndef ENUMS_H
 #include "enums.h"
#endif
#ifndef INTUITIONBASE_H
#include <intuition/intuitionbase.h>
#endif
#include <exec/execbase.h>

/********************************************************************
 *  global variables are in "globalvars.c" - link them to this code *
 *  or define GLOBALINCLUDE to #include them                        *
 ********************************************************************/

#ifndef GLOBALVARS_H
#include "globalvars.h"
#endif

#ifdef GLOBALINCLUDE
 #include "globalvars.c"
#endif

#define MASTERINFO "T:masterinfo"

/* Prototypes for functions defined in Arn.c */
/* proto$start */
void ErrorHandle(int ErrMsgNr, char *addinfo);
void ToggleScreenTitle(void);
int CloseArn(void);
void InitArn(int mode);
int SetUp(void);
int SetPriority(char *prio);
int checkswitches(int *sw,
                  char **argvp,
                  int argc);
void DirOnly(void);
int main(int argc,
         char **argv);
/* proto$end */

/* external prototypes */
#include "proto/ArnIO_proto.h"
#include "proto/grouplist_proto.h"
#include "proto/getconfig_proto.h"
#include "proto/time_proto.h"
#include "proto/choosegroups_proto.h"
#include "proto/readgroup_proto.h"
#include "proto/followup_proto.h"
#include "proto/kill_proto.h"
#ifdef LATTICE_50
#include "proto/raw_proto.h"
#endif


/* from version.c */
extern char *commover,*Version, *Last_UpdateD, *Last_UpdateT;
/* from choosegroups.c */
extern char *Menulines[];
extern max_grouplines;
/* from ArnIO.c */
extern char *tc_vector, *commonkeys;

#ifdef ARNLOGO
/* from Arnlogo.c */
extern char *ArnLogo();
#endif

                 /***********************************/

#ifdef AZTEC
extern int Enable_Abort;
#endif

char  *dironly;
UWORD ScrBarHeight= 0;
long  OldPriority=0L;
struct ExecBase *ExecBase;
struct TagItem Tag1[3]=
{
  SA_DisplayID, 0L,
  TAG_DONE, 0L,
  TAG_DONE, 0L
};

struct TextFont *ArnTxtFont= NULL;
char *TermName= NULL;

char *InitMessage="Arn %s (%s/%s)\nCopyright  1990-93 by Roland Bless,\
 Blessed Software Products\n\
Written 1990-93 by Roland Bless, all rights reserved.\n%s\n";

/***************************************************************************/

#ifdef AZTEC
long Chk_Abort()
{
  return 0L;
}
#endif

void ErrorHandle(ErrMsgNr,addinfo)
int ErrMsgNr;
char *addinfo; /* additional info */
{
  char *errtmp, *errtmp2;

  if (ErrMsgNr == USAGE)
  {
     fprintf(ERROUT, "Arn usage: %s [-?ipgsXRP(n)] [-Tterminal] [-Ddirname]\n", prgname);
     ErrMsgNr= INFO;
  }
  if (ErrMsgNr == INFO)
  {
     fprintf(ERROUT, "Arn %s (%s/%s)  -- (C)opyright by Roland Bless\n", Version,
             Last_UpdateD, Last_UpdateT);
  }
  else
  {
    errtmp= AllocMem((ULONG) 2*MAXLINE,MEMTYPE);
    errtmp2= errtmp+MAXLINE;
    if (errtmp)
    {
      sprintf(errtmp2,ErrMsg[ErrMsgNr],addinfo);
      sprintf(errtmp, "%s: %s\n", prgname, errtmp2);

      if (ErrMsgNr!=QUITARN && ErrMsgNr!=NONEWSGROUP)
         fprintf(ERROUT, "%s", errtmp);

      if (conWriteReq) DispMsg(errtmp);
    }
    else
      fprintf(ERROUT, "\n%s: %s", prgname, ErrMsg[ErrMsgNr]);

    if (errtmp) FreeMem(errtmp, (ULONG) 2*MAXLINE);
    GlobalERROR= ErrMsgNr;
  }
}


void
ToggleScreenTitle(void)
{
  struct IntuiMessage *message;
  ULONG class;
  SHORT deltaY, FontHeight;

  if (auxmode) return;

  FontHeight= ArnWin->RPort->TxHeight;
  deltaY=ScrBarHeight;

  if (GeneralBool & SCREENTITLE)
  {
    ShowTitle(ArnScreen, FALSE);
    MoveWindow(ArnWin, 0, -deltaY);
    SizeWindow(ArnWin, 0, deltaY);
    Wait(1L << ArnWin->UserPort->mp_SigBit);
    if (message= (struct IntuiMessage *) GetMsg(ArnWin->UserPort))
    {
      class= message->Class;
      ReplyMsg((struct Message *) message);
      SetSignal(0L,1L << ArnWin->UserPort->mp_SigBit);
    }
    (*ConWrite)("\x9bl\x9bt");  /* Reset Console Bottom */
    MaxScrLines= ArnWin->Height / FontHeight;
    GeneralBool&= ~SCREENTITLE;
  }
  else
  {
    SizeWindow(ArnWin, 0, -deltaY);
    MoveWindow(ArnWin, 0, deltaY);
    ShowTitle(ArnScreen, TRUE);
    Wait(1L << ArnWin->UserPort->mp_SigBit);
    if (message= (struct IntuiMessage *) GetMsg(ArnWin->UserPort))
    {
      class= message->Class;
      ReplyMsg((struct Message *) message);
      SetSignal(0L,1L << ArnWin->UserPort->mp_SigBit);
    }
    (*ConWrite)("\x9bl\x9bt"); /* Reset Console Bottom */
    MaxScrLines= ArnWin->Height / FontHeight;
    GeneralBool|= SCREENTITLE;
  }
}


int
CloseArn(void)
{
  struct EasyStruct CloseAllWindowsEReq =
  {
    sizeof(struct EasyStruct),
    0,
    "Arn Screen Request",
    "Please close all open windows!!\nArn wants to close its screen!",
    "Yes, I did"
  };


  if (conWriteReq || auxmode) DispMsg("\nArn - Shutdown: ");
  FreeNIL();
  if (conWriteReq || auxmode) DispMsg("1..");
  FreeGIL();
  if (conWriteReq || auxmode) DispMsg("2..");
  FreeKill_List(GlobalKill_List);
  if (conWriteReq || auxmode) DispMsg("3..");

  FreeString(NodeName);
  FreeString(DomainName);
  FreeString(NewsFeed);
  FreeString(UserName);
  FreeString(RealName);
  FreeString(OrgaName);
  FreeString(NewsEditor);
  FreeString(MailEditor);
  FreeString(Moderators);

  if (tmp)          FreeMem(tmp, (ULONG) SUPERLINE+1UL);
  if (moretmp)      FreeMem(moretmp, (ULONG) SUPERLINE+1UL);
  if (cmdline)      FreeMem(cmdline, (ULONG) MAXLINE+1UL);
  if (fnametmp)     FreeMem(fnametmp, (ULONG) MAXLINE+1UL);
  if (pathtogroup)  FreeMem(pathtogroup, (ULONG) MAXLINE+1UL);
  if (mBuffer)      FreeMem(mBuffer, M_BUFFERSIZE);
  if (HeaderBuf)    FreeMem(HeaderBuf, sizeofHeaderBuf);
  if (newsgroup)    FreeMem(newsgroup, (ULONG) MAXLINE+1UL);

  FreeString(colordata);
  FreeString(newsdir);
  FreeString(dbasedir);
  FreeString(savedir);
  FreeString(grouplistfile);
  FreeString(uuconfigfile);
  FreeString(uuxname);
  FreeString(sendmail);
  FreeString(rnews);
  FreeString(filter);
  FreeString(externprg);
  FreeString(seqf);
  FreeString(shellwin);
  FreeString(MetaMail);
  FreeString(signfile);
  FreeString(AuxEditor);
  FreeString(headerfile);
  FreeString(activefile);
  FreeString(replyto);
  FreeString(headerline);
  FreeString(globalkillfile);
  FreeString(dironly);
  FreeString(TermName);

  if (commonkeys) FreeMem(commonkeys, strlen(tc_KEY_CURSOR_UP)+1UL);

  if (conWriteReq || auxmode) DispMsg("4..");

  if (searchpat.patlen) /* pattern still allocated */
  {
    if (searchpat.kmp_table) /* we had a KMP search method */
    {
      free(searchpat.pattern.kmppat);
      free(searchpat.kmp_table);
    }
    else /* we had a regular expression */
    {
      if (searchpat.pattern.regpat) free(searchpat.pattern.regpat);
    }
    searchpat.patlen=0;
  }

  if (conWriteReq || auxmode) DispMsg("5..");

  if (switches & SW_PRIORITY)
     SetTaskPri(FindTask(NULL),OldPriority);


  if (NullFH)
     Close((BPTR) NullFH);

  if (conWriteReq || auxmode) DispMsg("6.\n");

  if (auxmode)
  {
    rawcon(0);
  }
  if (tc_vector) FreeMem(tc_vector,TERMCAP_MAXSIZE);

  if (!condeverr)
     CloseDevice((struct IORequest *) conWriteReq);

  if (conWriteReq)
     DeleteStdIO(conWriteReq);

  if (conReadReq)
     DeleteStdIO(conReadReq);

  if (conWritePort)
     DeletePort(conWritePort);

  if (conReadPort)
     DeletePort(conReadPort);

  if (ArnWin)
     CloseWindow(ArnWin);

  if (ArnTxtFont) CloseFont(ArnTxtFont);

  if (ArnScreen)
  {
    while (!CloseScreen(ArnScreen))
    {
      if (LockPubScreen(PubScreenName))
      {
        EasyRequest(ArnScreen->FirstWindow, &CloseAllWindowsEReq, NULL);
        UnlockPubScreen(NULL, ArnScreen);
      }
    }
  }

  FreeString(PubScreenName);

  if (GfxBase)
     CloseLibrary((struct Library *) GfxBase);

  if (IntuitionBase)
     CloseLibrary((struct Library *) IntuitionBase);

  return (0);
}


void InitArn(int mode) /* mode: 0- normal startup, 1- noscreen startup */
{
  char *nulldev, *tmpcolor;
  long colornum;
  struct Screen *WBScreen;
  ULONG WBModeID;
  struct Rectangle rect;

  IntuitionBase= NULL;
  GfxBase= NULL;
  ArnScreen= NULL;
  ArnWin= NULL;
  IntuiMsg= NULL;

  conWriteReq= conReadReq= NULL;
  conWritePort= conReadPort= NULL;
  NullFH= InFH= OutFH= NULL;
  MyDir= NULL;

  /* Set I/O functions */
  if (auxmode)
  {
    rawcon(1);       /* sets buffer to 1 char -> getchar returns immedeatley */
    /* fmode(stdout,0);*/ /* mode A-> CRs get inserted before output */
    ConWrite= AuxWrite;
    ConWriteLn= AuxWriteLn;
    ConWriteChar= AuxWriteChar;
    GetKey= GetKeyAux;
    InFH= (struct FileHandle *) Input();
    OutFH= (struct FileHandle *) Output();
  }
  else
  {
    ConWrite= ConDevWrite;
    ConWriteLn= ConDevWriteLn;
    ConWriteChar= ConDevWriteChar;
    GetKey= GetKeyConDev;
  }

  GroupListFP= NULL;
  GlobalKill_List= NULL;
  condeverr= 1L;
  TZ_Offset= 0L;
  GeneralBool= (EDSCRSWITCH | SHELLWINSW | GLOBALKILLON | LOCALKILLON | MOREDIRS) & ~SCREENTITLE;
  rotnumber=13;

  RootGI= NULL;
  RootArt= NULL;

  nextcmd= NULL;
  searchpat.patlen=0;
  searchpat.kmp_table= NULL;
  searchpat.pattern.kmppat= NULL;
  searchpat.pattern.regpat= NULL;

  tmp= (char *) AllocMem((ULONG) SUPERLINE+1L, MEMTYPE);
  moretmp= (char *) AllocMem((ULONG) SUPERLINE+1L, MEMTYPE);
  cmdline= (char *) AllocMem((ULONG) MAXLINE+1L, MEMTYPE);
  fnametmp= (char *) AllocMem((ULONG) MAXLINE+1L, MEMTYPE);
  pathtogroup= (char *) AllocMem((ULONG) MAXLINE+1L, MEMTYPE);
  newsgroup= (char *) AllocMem((ULONG) MAXLINE+1L, MEMTYPE);
  mBuffer= (char *) AllocMem(M_BUFFERSIZE, MEMTYPE);
  HeaderBuf= (char *) AllocMem(sizeofHeaderBuf, MEMTYPE);

  if (!(tmp && moretmp && cmdline && fnametmp &&
        newsgroup && mBuffer && HeaderBuf))
  {
    ErrorHandle(NOMEM,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }

  if (!(ExecBase = (struct ExecBase *) OpenLibrary("exec.library", 0L)))
  {
    ErrorHandle(STRANGE,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }
  else
  {
    OS_VER=ExecBase->LibNode.lib_Version;      /* Get the OS-Version */
    CloseLibrary((struct Library *) ExecBase);
  }


  if (!(IntuitionBase = (struct IntuitionBase *)
      OpenLibrary("intuition.library", 0L)))
  {
    ErrorHandle(NOINTUI,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }

  if (!(GfxBase= (struct GfxBase *)
        OpenLibrary("graphics.library", 1L)))
  {
    ErrorHandle(FATALERR,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }

  /* Init some variables */

  cmdline[0]='\0';
  timez[0]='\0';
  quotechar[0]='\0';
  SubjectOrder=false;

  /***********************/

  /* InitTerminalCodes */
  InitTerminalCodes();

  if (mode==1) return;

  if (OS_VER < 37L)
     ErrorHandle(WRONGVERSION,NULL);

  if (GlobalERROR)
  {
    CloseArn();
    exit(RETURN_ERROR);
  }

  nulldev="NIL:";

  if (!(NullFH= (struct FileHandle *) Open(nulldev, 1006L)))
  {
    ErrorHandle(NONULLDEV,NULL);
  }

  if (auxmode) return;

  InFH= OutFH= NullFH;
  /***************** amiga only mode starts here! **************/

  ArnNewScreen.Height= GfxBase->NormalDisplayRows;

  /* Get default settings from WB->Screen */

  WBScreen= LockPubScreen("Workbench");
  if (WBScreen)
  {
    WBModeID=GetVPModeID(&WBScreen->ViewPort);
    if (WBModeID!=INVALID_ID)
    {
      ArnNewScreen.Height= WBScreen->Height;
      ArnNewScreen.Width= WBScreen->Width;
      Tag1[0].ti_Data=WBModeID;
      if (QueryOverscan(WBModeID, &rect, OSCAN_TEXT))
      {
        ArnNewScreen.Height= rect.MaxY-rect.MinY+1;
        ArnNewScreen.Width= rect.MaxX-rect.MinX+1;
      }
    }
  }

  GetScreenData(mBuffer,(long) sizeof(struct Screen), WBENCHSCREEN, NULL);

  ArnScreen=(struct Screen *) mBuffer;

  if (WBScreen)
     UnlockPubScreen(NULL, WBScreen);
  else
  {    /* we already got this information */
    ArnNewScreen.Height= ArnScreen->Height;
    ArnNewScreen.Width= ArnScreen->Width;
  }

  ArnNewScreen.Font= NULL;                    /* System Default Font */
  ArnNewScreen.DetailPen= ArnScreen->DetailPen;
  ArnNewScreen.BlockPen= ArnScreen->BlockPen;
  ArnNewScreen.ViewModes= ArnScreen->ViewPort.Modes;

  ArnScreen= NULL;

  /* Get User-defined ScreenData */

  if (GetArnConfig(true))
  {
    ErrorHandle(CONFIGERROR,NULL);
    CloseArn();
    exit(GlobalERROR);
  }

  if (ArnNewScreen.Depth>1)
  {
    EmphON= "\033[33;40m";
    EmphOFF= "\033[31;40m";
  }

  if (PubScreenName)
  {
    Tag1[1].ti_Tag= SA_PubName;
    Tag1[1].ti_Data= (ULONG) PubScreenName;
  }

  ArnScreen= OpenScreenTagList(&ArnNewScreen,Tag1);
  if(!ArnScreen)
  {
    ErrorHandle(NOSCREEN,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }
  else
  {
    if (tmpcolor = colordata)
    {
      int i;

      for(i= 0;i<(1L<<ArnNewScreen.Depth);i++)
      {
        colornum= strtol(tmpcolor,&tmpcolor,NULL);
        SetRGB4(&(ArnScreen->ViewPort),i,(colornum >> 8) & 0xf, (colornum >> 4) & 0xf, colornum & 0xf);
      }
      RemakeDisplay();
    }
  }

  ScrBarHeight= ArnScreen->BarHeight+1;

  ArnNewWin.Screen= ArnScreen;
  ArnNewWin.Height= ArnScreen->Height;
  ArnNewWin.Width= ArnScreen->Width;

  if (!(ArnWin= (struct Window *) OpenWindow(&ArnNewWin)))
  {
    ErrorHandle(NOWIN,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }

  if (ArnTxtFont) SetFont(ArnWin->RPort, ArnTxtFont);
  SetRast(ArnWin->RPort, 0L);
  /* Get the right number of maximum lines and chars per line */
  MaxScrLines= ArnWin->Height / ArnWin->RPort->TxHeight;
  MaxChars=    ArnWin->Width / ArnWin->RPort->TxWidth;

  if (MaxChars<80)
  {
    ErrorHandle(FATALERR,"Font cannot display 80 chars/line!");
    CloseArn();
    exit(RETURN_ERROR);
  }

  conWritePort = CreatePort("ArnConW", 0L);
  if (!conWritePort)
  {
    ErrorHandle(NOPORT,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }
  conWriteReq  = CreateStdIO(conWritePort);
  if (!conWriteReq)
  {
    ErrorHandle(FATALERR,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }

  conReadPort = CreatePort("ArnConR", 0L);
  if (!conReadPort)
  {
    ErrorHandle(NOPORT,NULL);
    CloseArn();
    exit(RETURN_ERROR);

  }

  conReadReq  = CreateStdIO(conReadPort);
  if (!conReadReq)
  {
    ErrorHandle(FATALERR,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }

  conWriteReq->io_Data   = (APTR)ArnWin;
  conWriteReq->io_Length = sizeof(*ArnWin);
  condeverr= OpenDevice ("console.device", 0L,(struct IORequest *) conWriteReq,
                          0L);

  if (condeverr)
  {
    ErrorHandle(FATALERR,NULL);
    CloseArn();
    exit(RETURN_ERROR);
  }

  conReadReq->io_Device  = conWriteReq->io_Device;
  conReadReq->io_Unit    = conWriteReq->io_Unit;

  ShowTitle(ArnScreen, FALSE);

  if (PubScreenName) PubScreenStatus(ArnScreen, 0);
}



int
SetUp(void)
{
  char *c;
  int rc; /* return code */

#ifdef ARNLOGO
  (*ConWriteLn)(ArnLogo());
#endif

  ClrScr();
  sprintf(tmp, InitMessage, Version, Last_UpdateD, Last_UpdateT, TimeStr(0));
  (*ConWrite)(tmp);

  (*ConWrite)("Initialization:\n");

  (*ConWrite)("reading Arn config-file,\n");
  if (GetArnConfig(false)) /* get the full configs */
  {
     ErrorHandle(CONFIGERROR,NULL);
     return GlobalERROR;
  }
  else
  {
    (*ConWrite)(" UUCP config-file,\n");
    if (getconfig())
    {
      ErrorHandle(UUCONFERROR,NULL);
      return GlobalERROR;
    }
  }
  (*ConWrite)(" active-file,\n");
  if (activefile)
    if(ReadActiveFile()) /* error with activefile */
    {
      return GlobalERROR;
    }

  (*ConWrite)(" GROUPLIST,\n");
  if (rc= GetGroups())
  {
    if (rc!=1) /* rc==1 means that no grouplist was found */
      return GlobalERROR;
  }

  GlobalERROR= OK;

  strcpy(fnametmp,grouplistfile); /* Get dir where grouplistfile is */
  if(c= PathPart(fnametmp)) *c='\0';

  sprintf(tmp,".glX%s",UserName);
  if (AddPart(fnametmp, tmp, MAXLINE))
  {
    globalkillfile= CopyString(fnametmp);
    ReadKillFile(&GlobalKill_List,globalkillfile);  /* Read in the global Kill-File */
    (*ConWrite)(" global X-file,\n");
  }

  (*ConWriteLn)(" OK.\n");

  sprintf(tmp,"Welcome!\n\nNodeName: %s UserName: %s (%s)\n\
Organization: %s\n\nPress H (shift-H) for help.",
          NodeName,UserName,RealName,OrgaName);
  (*ConWriteLn)(tmp);
  ConCR();

  if (switches & SW_STOPMODE)
  {
    ConWriteLn("Press any key to continue...");
    GetUpKey();
  }
  return OK;
}


int
SetPriority(char *prio)
{
  char buf, *t;
  long priority;

  for (t= prio; *t!='\0' && (isdigit(*t) || *t=='-'); t++);

  buf=*t;
  *t= '\0';
  if (*prio=='\0')
  {
    *t=buf;
    return 0;
  }
  else
   priority= atol(prio);

  if (priority>=-127 || priority<=128)
  {
     OldPriority= SetTaskPri(FindTask(NULL),priority);
     switches|= SW_PRIORITY;
  }

  *t= buf;
  return (int) (t-prio);
}


int checkswitches(int *sw, char **argvp, int argc)
{
  int i,j;
  BOOL leave;

  for (*sw= 0,j= 1; j<argc;j++)
  {
    if (*argvp[j]=='-')
    {
      for (i= 1, leave= false; argvp[j][i]!='\0' && !leave; i++)
      {
        switch(argvp[j][i])
        {
          case 'T': auxmode= true;
                    TermName= CopyString(&argvp[j][i+1]);
                    leave= true;
                    break;
          case '?':
          case 'i': *sw|= SW_INFO;
                    break;
          case 'p': *sw|= SW_POSTARTICLE;
                    break;
          case 'D': *sw|= SW_DIRONLY;
                    dironly= CopyString(&argvp[j][i+1]);
                    leave= true;
                    break;
          case 'R': *sw|= SW_RESETGROUPLIST;
                    break;
          case 'X': *sw|= XFILE_EXPIRE;
                    break;
          case 'g': *sw|= SW_GOTOGROUP;
                    break;
          case 'P': i+= SetPriority(&(argvp[j][i+1]));
                    /* SW_PRIORITY is set if prio is changed */
                    break;
          case 's': *sw|= SW_STOPMODE;
                    break;
           default: ErrorHandle(USAGE,NULL);
                    return 1;
                    break;
        }
      }
    }
    else
    {
      ErrorHandle(USAGE,NULL);
      return 1;
      break;
    }
  }
  return 0;
}


void
DirOnly(void)
/* creates database for one directory, reads it and returns */
{
  struct GroupInfoList tmpGI;
  int command= REFRESHSCREEN;
  char *c;
  int i;
  extern int grouplines;

  RootGI= &tmpGI;
  RootGI->Name= dironly;
  RootGI->NextGI= RootGI->PrevGI= NULL;
  RootGI->Marks= NULL;
  RootGI->Status= SUBSCRIBED | LASTBIT | NEWARTS_GROUP;
  RootGI->RootSubjP= NULL;
  RootGI->OldlastArtNr= RootGI->UserlastArtNr= 0L;
  DispMsg("Creating database for "); DispMsg(dironly);
  DispMsg("...please standby...\n");
  sprintf(tmp, "arnmaster -G %s", dironly);
  Execute(tmp, (BPTR) NullFH, (BPTR) NullFH);
  if (fp=fopen(MASTERINFO,"r"))
  {
    fscanf(fp,"%lu %lu",&(RootGI->lastArtNr),&(RootGI->firstArtNr));
    fclose(fp);
    remove(MASTERINFO);
  }

  max_grouplines= grouplines= MaxScrLines>=(MAX_SELECT_LINES+2) ? MAX_SELECT_LINES : MaxScrLines-2; /* Less lines than 26 ? */
  if (c= AllocMem((ULONG) (max_grouplines * ((ULONG)MaxChars+1UL)), MEMTYPE))
  {
    for (i= 0; i<max_grouplines; i++)
       Menulines[i]= &c[i*(MaxChars+1)];
  }
  ReadGroup(RootGI,&command);
  RootGI= NULL; /* Nothing to free, because this struct was temporary on stack */
  if (c) FreeMem(c, (ULONG) (max_grouplines * ((ULONG)MaxChars+1UL)));
  sprintf(fnametmp,"%s/.newsdb",dironly);
  remove(fnametmp);
}

#ifdef __SASC
int nop_func(void) /* replaces break trap */
{
  return 0;
}
#endif


int
main(int argc, char **argv)
{
  short returncode= 0;
  int choosegroups_cmd;

#ifdef __SASC
  onbreak(&nop_func);
#endif

  Version= &commover[11];
  fclose(stderr);         /* Only if ERROUT!=stderr */

#ifdef AZTEC
  Enable_Abort= 0;
#endif
  prgname= *argv;
  GlobalERROR= OK;

  checkswitches(&switches, argv, argc);

  if (switches & SW_INFO)
  {
    ErrorHandle(USAGE,NULL);
    exit(RETURN_OK);
  }

  if (switches & XFILE_EXPIRE)
  {
    printf(InitMessage, Version, Last_UpdateD, Last_UpdateT, TimeStr(0));
    printf("Entering X-file expire mode.\n");
    InitArn(1); /* QUIET Mode */
    ExpireXfiles();
    CloseArn();
    return RETURN_OK;
  }

  if (switches & SW_RESETGROUPLIST)
  {
    printf(InitMessage, Version, Last_UpdateD, Last_UpdateT, TimeStr(0));
    printf("Resetting GROUPLIST.\n");
    InitArn(1); /* QUIET Mode */
    GetArnConfig(false);
    ResetGroupList();
    CloseArn();
    return RETURN_OK;
  }

  InitArn(0);  /* Built Screen */

  if (SetUp()) /* GETGROUPS is executed in setup! */
  {
    ErrorHandle(SETUP,NULL);
    returncode= GlobalERROR;
  }
  else
  {
#ifdef TESTKEY
    strcpy(tmp,"This is a test.");
    (*ConWriteLn("Input:"));Getline(tmp,30);
#endif
    if (switches & SW_DIRONLY)
    {
      FreeGIL();  /* GetGroups was executed, so free all groups */
      DirOnly();
      returncode= QUITARN;
    }
    else
    {
      if (switches & SW_POSTARTICLE)
      {
        PostArticle(NULL);
        returncode= QUITARN;
      }
      else
      {
         do
         {
           choosegroups_cmd= QUIT;
           returncode= ChooseGroups(&choosegroups_cmd);
           switch (choosegroups_cmd)
           {
              case REREAD_ACTIVE:
                                  StatusLine();
                                  DispMsg("Rereading ");
                                  DispMsg(activefile);
                                  DispMsg("...");
                                  ReReadActiveFile();
                                  break;
              default:            choosegroups_cmd= QUIT;
                                  break;
           }
         }
         while(choosegroups_cmd!=QUIT);
      }
    }
  }
  if (RootGI && !returncode)
  {
    sprintf (tmp, "\nupdating %s...moment please...", grouplistfile);
    StatusLine();
    DispMsg(tmp);
    if (UpdateGroupList()== 0)
       sprintf (tmp, "ready!\n");
    else
       sprintf (tmp, "some trouble...ready!\n");
    DispMsg(tmp);
  }

  StatusLine();
  ClrLine();
  DispMsg("Goodbye!");

  if (GlobalERROR && !auxmode)
  {
    DispMsg(" - Press any key to quit.");
    (*GetKey)();
  }

  ErrorHandle(QUITARN,NULL);

  CloseArn();
}
