#ifndef INCLUDES_SYM
#include "includes.h"
#endif

/* Prototypes for functions defined in dirfunc.c */
/* proto$start */
BOOL Exists(char *name);
void CreateDir_IfNotExists(char *name,
                           char *name_end);
/* proto$end */

BOOL
Exists(char* name)
/* returns true if file/dir with name exists */
{
  BPTR file_lock;

  file_lock= Lock(name, ACCESS_READ);
  if (file_lock)
  {
    UnLock(file_lock);
    return true;
  }
  else
    return false;
}


void CreateDir_IfNotExists(char *name, char *name_end)
{
  char *pathtmp;
  BPTR dirlock;

  if (*name=='\0' || Exists(name)) return;
  else
  {
    /* search previous backslash */
    for(pathtmp= name_end; pathtmp!=name && *pathtmp!='/'; pathtmp--);
    if (*pathtmp=='/')
    {
      *pathtmp='\0';
      CreateDir_IfNotExists(name,pathtmp); /* create parent if not existent */
      *pathtmp= '/';
      dirlock=CreateDir(name);          /* all parent dirs should exist now */
      if (dirlock) UnLock(dirlock);
    }
  }
}
