#ifndef ENUMS_H
#define ENUMS_H
                             /* ErrorMsgs */

enum { OK, WRONGVERSION, NOINTUI, NOSCREEN, NOWIN, NOPORT, NOTIMER,
       FATALERR, STRANGE, CONFIGERROR, UUCONFERROR, SETUP, SEQFNOTFOUND,
       NOMEM, NONEWSDIR, NONEWSGROUP, GROUPLIST, REGEXP, NOACTIVE,
       NOVALIDGROUP, NONULLDEV, WARNUUX, WARNSMAIL, WARNQUOTE, WARNTZNAME,
       WARNTZOFFSET, NOFROM, NOSUBJ, DBASECORRUPT, INVALIDMODE, WARNNOFONT,
       NOTERMCAP, INCOMPLETE_TERMCAP, OBSOLETEGROUP, NOTMPFILE, QUITARN,
       INFO, USAGE };

                             /* Article Display Modi */
enum { SUBJ_ALPHABET, SUBJ_DATE, ART_DATE, COMPACT_ALPHABET, COMPACT_DATE };

   /* Flags for Articles */
#define UNREAD        0x0000
#define READ          0x0001
#define UNUSED_FLAG   0x0002
#define NONEXISTENT   0x0004
#define PARENTART     0x0008
#define FOLLOWUPART   0x0010
#define PA_WITHF      0x0020
#define FUP_WITHF     0x0040
#define XREF          0x0080
#define NEW           0x0100
#define SELECTED_ART  0x0200
#define NEEDS_REFRESH 0x0400
#define ALL           0xffff

  /* Flags for Newsgroups  */
#define SUBSCRIBED      0x00
#define UNSUBSCRIBED    0x01
#define UNUSED_GFLAG    0x02
#define MODERATED       0x04
#define SELECTED_GROUP  0x08
#define UNREAD_GROUP    0x10
#define NEWARTS_GROUP   0x20
#define NEW_GROUP       0x40
#define G_NEEDS_REFRESH 0x80
#define LASTBIT         0x8000

 /* Flags for commandline switches */

#define SW_INFO           0x01
#define SW_POSTARTICLE    0x02
#define XFILE_EXPIRE      0x04
#define SW_RESETGROUPLIST 0x08
#define SW_GOTOGROUP      0x10
#define SW_PRIORITY       0x20
#define SW_DIRONLY        0x40
#define SW_STOPMODE       0x80

                             /* Help topics */

enum { H_MORE, H_ARTSEL, H_GROUPSEL };

                               /* Commands */

enum { QUIT, BREAK,
       NEXTGROUP, PREVGROUP,
       LASTPAGE, FIRSTPAGE,
       PAGEBACK, PAGEFORWARD, LINEUP, LINEDOWN,
       REFRESHSCREEN, REFRESHLINE, REFRESHLINES, REBUILD,
       SELECTRANGE, SELECT_NEW, SELECT_THREAD, SELECT, UNSELECT,
       SELECT_ALL, UNSELECT_ALL, SELECT_INVERSE,
       NEXTART, PREVART,
       UNREADART, READART,
       STAY, NEXTP, PREVP, SAMEP,
       VERBOSE, TOP, BOTTOM, TAB, SPACE, NEXTLINE,
       NOP, GOTO, JUNK,
       CATCHUP, UNSUB, RESUBSCRIBE,
       READNOW, READNOW_ANDCATCHUP,
       ENTERGROUP,TOGROUPDIR, TOARTDIR,
       FOLLOWUP, Q_FOLLOWUP, QSP_FOLLOWUP, REPLY, Q_REPLY, FORWARD_ART,
       SAVEART_WH, SAVEART_NH,
       SEARCH_INART_F, SEARCH_INART_B,
       SEARCH_GROUP_F, SEARCH_GROUP_B,
       SEARCH_PAT,
       GOTO_GROUP, CURSOR_TO_GROUP,
       LIST_SUBJ,
       STATUS,
       POSTARTICLE,
       CANCELART, EXTERN_PRG,
       LISTGROUPS,
       EDIT_KILL, ADDTO_LOCALKILL,
       SHOWALL, SHOW_UNSUBS,
       REREAD_ACTIVE,
       TOGGLE_SCREENTITLE,
       MARK_THREAD_READ,
       GROUPMENU, MISCMENU, VIEWMENU,
       REBUILD_DISPLAY };



                     /* BOOL-Variables for GeneralBool */

#define EDSCRSWITCH 0x1L
#define SHELLWINSW  0x2L
#define EXTERNWIN   0x4L
#define MOREDIRS    0x8L
#define SCREENTITLE 0x10L
#define G_MODERATED 0x20L
#define ROT13       0x40L
#define GENFROMLINE 0x80L
#define EXTERNSCRSW  0x100L
#define HEADERSTOP   0x200L
#define CLEARSCREEN  0x400L
#define GLOBALKILLON 0x800L
#define LOCALKILLON     0x1000L
#define GENDATELINE     0x2000L
#define CATCHUP_XREFS   0x4000L
#define UPDATE_NEWMARKS 0x8000L
#define ASK_FOR_AUTOSELECT 0x10000L

enum { PATH_NONE, PATH_USER, PATH_DOMAIN, PATH_FULL };

     /* reply-mode */
enum { QUOTE, NOQUOTE, FORWARD };

/* attributes for struct kill_strings */
#define CASESENSITIVE 1
#define MATCHBEGIN    2
#define REGULAREXPR   4

/* these defines are not needed currently!! */
#define HD_APPROVED     0x0001
#define HD_DISTRIBUTION 0x0002
#define HD_CONTROL      0x0004
#define HD_DATE         0x0008
#define HD_FROM         0x0010
#define HD_SENDER       0x0020
#define HD_NEWSGROUP_C  0x0040
#define HD_NEWSGROUP_X  0x0080
#define HD_MESSAGE_ID   0x0100
#define HD_KEYWORDS     0x0200
#define HD_LINES        0x0400
#define HD_NEWSGROUPS   0x0800
#define HD_NEWSGROUPS_X 0x1000
#define HD_ORGANIZATION 0x2000
#define HD_PATH         0x4000
#define HD_REPLY_TO     0x8000
#define HD_SUBJECT      0x00010000
#define HD_FOLLOW_UPTO  0x00020000
#define HD_REFERENCES   0x00040000
#define HD_SUMMARY      0x00080000
#define HD_Xall         0x00100000
#define HD_CONTENT_TYPE 0x00200000
#define HD_CONTENT_XFER_ENCODING 0x00400000
/* end header defines */

/* headercodes for HeaderLines */
enum { HL_APPROVED, HL_DISTRIBUTION, HL_CONTROL, HL_DATE, HL_FROM, HL_SENDER,
       HL_NEWSGROUPS, HL_MESSAGE_ID, HL_ARTICLE_ID, HL_KEYWORDS, HL_LINES,
       HL_ORGANIZATION, HL_PATH, HL_REPLY_TO, HL_SUBJECT, HL_FOLLOWUP_TO,
       HL_REFERENCES, HL_SUMMARY, HL_TITLE, HL_EXPIRES, HL_SUPERSEDES,
       HL_X_ALL, HL_CONTENT_TYPE, HL_CONTENT_XFER_ENCODING, HL_STOP };

#endif
