/*************************************************************************
 * globalvars.c -- Global variable declarations/definitions for all      *
 *                 modules of Arn                                        *
 * (C)opyright 1990-1992 by Roland Bless of Blessed Software Products    *
 *************************************************************************/


#ifndef INCLUDES_SYM
 #include "includes.h"
#endif

#ifdef __SASC
__buffsize= BUFSIZ;
#endif

                  /* Definition of global variables */

                            /* Variables */

struct IntuitionBase *IntuitionBase= NULL;
struct GfxBase       *GfxBase= NULL;
struct Screen        *ArnScreen= NULL;
struct Window        *ArnWin= NULL;
struct IntuiMessage  *IntuiMsg= NULL;

struct IOStdReq *conWriteReq= NULL,  *conReadReq= NULL;
struct MsgPort  *conWritePort= NULL, *conReadPort= NULL;
struct FileHandle *NullFH=NULL, *InFH=NULL, *OutFH=NULL;

                     /* "Own" Variables */
BOOL auxmode= false;
void (*ConWrite)(char *text);   /* writes text to console */
void (*ConWriteLn)(char *text); /*  "       "   "   "     adding a (CR)LF */
void (*ConWriteChar)(char c);   /* writes a single char to console */
char (*GetKey)(void);           /* Waits for a key and returns it if pressed */
FILE *fp, *GroupListFP;
struct FileLock *MyDir;
int GlobalERROR, MaxScrLines, MaxChars, defcomm, switches, rotnumber;
long condeverr, TZ_Offset;
ULONG NrOfGroups, NrOfArticles;
ULONG GeneralBool= 0UL;           /* GeneralBoolean-Variable */
ULONG sizeofHeaderBuf= SIZEOF_HEADERBUF;
struct kill_field *GlobalKill_List; /* Global Kill-List */
BOOL SubjectOrder= false;
UWORD OS_VER;

unsigned char casedep= 0x5F;            /* CASE INDEPENDENT for Match() */
char* prgname;

char *tmp=NULL,                /* general tmp string SUPERLONG */
     *moretmp=NULL,            /* needed for the pager SUPERLONG */
     *cmdline=NULL,            /* Commandline-String */
     *fnametmp=NULL,           /* filename-String */
     *pathtogroup=NULL,        /* full path to group (MAXLINE)*/
     *pathtodbase=NULL,        /* full path to dbasedir (variable len) */
     *nextcmd=NULL,            /* Next command in cmdline, if any */
     *mBuffer=NULL,            /* Multi-Purpose-Buffer */
     *HeaderBuf=NULL,          /* Buffer for header data */
     *newsgroup=NULL,
     *newsdir=NULL,            /* arnconfig: news-dir */
     *dbasedir=NULL,           /* arnconfig: dbase-dir */
     *savedir=NULL,            /* arnconfig: savedir */
     *activefile=NULL,         /* arnconfig: activefile */
     *grouplistfile=NULL,      /* arnconfig: name of .newsrc-file */
     *uuconfigfile=NULL,       /* arnconfig: name of uuconfigfile */
     *seqf=NULL,               /* arnconfig: wheres the seq-nr for news? */
     quotechar[5],             /* arnconfig: quotechar */
     timez[6],                 /* arnconfig: timezone-name */
     *signfile=NULL,           /* arnconfig: where's the signature */
     *headerfile=NULL,         /* arnconfig: where's the headerfile */
     *replyto=NULL,            /* arnconfig: special reply-address */
     *uuxname=NULL,            /* arnconfig: which prg sends the news? */
     *sendmail=NULL,           /* arnconfig: which prg sends the mail? */
     *shellwin=NULL,           /* arnconfig: shell-window */
     *rnews=NULL,              /* arnconfig: which prg gets the article? */
     *externprg=NULL,          /* arnconfig: external program */
     *filter=NULL,             /* arnconfig: filter for article to send */
     *colordata=NULL,          /* arnconfig: custom colors */
     *headerline=NULL,         /* arnconfig: headerline string */
     *globalkillfile=NULL,     /* derived from grouplistfile */
     *AuxEditor=NULL,          /* arnconfig: editor in AUX:-mode */
     *MetaMail=NULL,           /* arnconfig: Metamail call */
     *PubScreenName= NULL,     /* arnconfig: PublicScreen Name */
     *NodeName=NULL,   /* from UUConfig */
     *NewsFeed=NULL,
     *DomainName=NULL,
     *UserName=NULL,
     *RealName=NULL,
     *OrgaName=NULL,
     *NewsEditor=NULL,
     *MailEditor=NULL,
     *Moderators=NULL; /*** end UUConfig ****/

struct search_struct /* Searchpattern for "/" */
{
  union pattern_union
  {
    regexp *regpat;  /* regular expression */
    char   *kmppat;  /* KMP expression */
  } pattern;
  short int *kmp_table; /* Array of ints that hold table values for KMP */
  int patlen;
} searchpat;


                       /* Termcap codes */
char *tc_BOLDFACE_ON= NULL,
     *tc_BOLDFACE_OFF= NULL,
     *tc_UNDERLINE_ON= NULL,
     *tc_UNDERLINE_OFF= NULL,
     *tc_SLANTED_ON= NULL,
     *tc_SLANTED_OFF= NULL,
     *tc_INV_ON= NULL,
     *tc_INV_OFF= NULL,
     *tc_GOTO_XY= NULL,
     *tc_CURSOR_UP= NULL,
     *tc_CURSOR_DOWN= NULL,
     *tc_CURSOR_LEFT= NULL,
     *tc_CURSOR_RIGHT= NULL,
     *tc_CLRSCR= NULL,
     *tc_CLR_TO_EOL= NULL,
     *tc_EOL= NULL,
     *tc_DELCHAR= NULL,
     *tc_INSCHAR= NULL,
     *tc_KEY_CURSOR_UP= NULL,
     *tc_KEY_CURSOR_DOWN= NULL,
     *tc_KEY_CURSOR_LEFT= NULL,
     *tc_KEY_CURSOR_RIGHT= NULL,
     *tc_KEY_BACKSPACE= NULL,
     *tc_KEY_DELCHAR= NULL,
     *EmphON,*EmphOFF; /* Emphasize Arn's Messages */

struct GroupInfoList *RootGI, *LastGroup;    /* structs are in includes.h */
struct art_struct *RootArt, *pArt, *LastArt;

char *ErrMsg[]= {
  "OK",
  "FATAL ERROR: Your OS is really _obsolete_!  Kickstart V37 is required at least!",
  "FATAL ERROR: Can't find/open intuition.library!",
  "FATAL ERROR: Can't open my screen!",
  "FATAL ERROR: Can't open my window!",
  "FATAL ERROR: Can't open a MsgPort!",
  "FATAL ERROR: Can't open the Timer!",
  "FATAL ERROR: Cannot continue! %s",
  "STRANGE ERROR: Something strange happened...(%s)!",  /* addinfo */
  "ERROR: Can't get my config-file, please check it!",
  "ERROR: UUConfig - required entry missing or file not found!",
  "ERROR: During startup!",
  "ERROR: No SEQFILE?!",
  "FATAL ERROR: Can't get enough memory!",
  "ERROR: Can't find the NEWSDIR!",
  "No spooldir available for %s",               /* addinfo */
  "ERROR: Cannot open GroupList: %s!",
  "ERROR: regexp: %s",
  "ERROR: Can't find the ACTIVEFILE!",
  "ERROR: Invalid entry in GROUPLIST!\n%s", /* addinfo */
  "WARNING: No NULL:-device mounted! Machine can crash if you close the CLI!",
  "WARNING: No 'uux' entry found! Took 'uux'.",
  "WARNING: No 'sendmail' entry found! Took 'sendmail'.",
  "WARNING: QuoteChar entry too long!",
  "WARNING: TimeZoneName missing or >5 chars, took GMT instead",
  "WARNING: GMT-Offset is in wrong format!",
  "ERROR: Wrong DBase-Format - missing From:! %s",
  "ERROR: Wrong DBase-Format - missing Subject:! %s",
  "ERROR: DBase-format corrupt: %s",
  "WARNING: Video-Mode not available!",
  "WARNING: Font %s not found!",
  "ERROR: No Termcap entry for %s found!",
  "ERROR: Termcap needs a <%s> entry !",
  "Info: %s is an obsolete group in GROUPLIST (deleted).",
  "ERROR: Couldn't open temporary file (%s)",
  "QUIT.",
  "INFO: Arn written by Roland Bless."
};  /* Messages for ErrorHandle/Numbers */


char *HeaderLines[]= {
  "Approved:",
  "Distribution:",
  "Control:",
  "Date:",
  "From:",
  "Sender:",
  "Newsgroups:",
  "Message-ID:",
  "Article-I.D.:",
  "Keywords:",
  "Lines:",
  "Organization:",
  "Path:",
  "Reply-To:",
  "Subject:",
  "FollowUp-To:",
  "References:",
  "Summary:",
  "Title:",
  "Expires:",
  "Supersedes:",
  "X-",
  "Content-Type:",
  "Content-transfer-encoding:"
};


struct NewScreen ArnNewScreen =
{
  0,0,                           /* LEdge, TEdge  */
  640, 256,                      /* Width, Height */
  1,                             /* BitPlanes     */
  0, 1,                          /* Front, Back-pen */
  HIRES,                         /* View Modes      */
  CUSTOMSCREEN,                  /* Screen-Type     */
  NULL,                          /* textattr *font  */
  (UBYTE *)"Arn Screen, Arn - Amiga USENET Newsreader,\
 Copyright  by R.Bless",   /* Title */
  NULL,                          /* Gadgets */
  NULL                           /* CustomBitMap */
};


struct NewWindow ArnNewWin =
   {
   0, 0,                /* LeftEdge, TopEdge   */
   640, 256,            /* Width, Height       */
   0, 1,                /* DetailPen, BlockPen */
   NEWSIZE,
   ACTIVATE |
   BORDERLESS | BACKDROP |
   SMART_REFRESH ,
   NULL,                /* First Gadget        */
   NULL,                /* CheckMark           */
   NULL,
   NULL,                /* Screen              */
   NULL,                /* BitMap              */
   50, 20,              /* Min Width, Height   */
   640, 256,            /* Max Width, Height   */
   CUSTOMSCREEN         /* Type                */
   };
