/* globalvars.h -- extern declarations */
/* This file contains just the declarations of global variables */
/* Definitions can be found in globalvars.c */
#ifndef GLOBALVARS_H
               /*************************************/
#define GLOBALVARS_H
                            /* Variables */

#ifndef INCLUDES_SYM
 #include "includes.h"
#endif

extern struct IntuitionBase *IntuitionBase;
extern struct GfxBase       *GfxBase;
extern struct Screen        *ArnScreen;
extern struct Window        *ArnWin;
extern struct IntuiMessage  *IntuiMsg;

extern struct IOStdReq *conWriteReq,  *conReadReq;
extern struct MsgPort  *conWritePort, *conReadPort;
extern struct FileHandle *NullFH,*InFH,*OutFH;

                     /* "Own" Variables */
extern char* prgname;
extern BOOL auxmode;
extern void (* ConWrite)(char *text);
extern void (* ConWriteLn)(char *text);
extern void (* ConWriteChar)(char c);
extern char (* GetKey)(void);
extern struct FileLock *MyDir;
extern FILE *fp, *GroupListFP;
extern long condeverr, TZ_Offset;
extern ULONG sizeofHeaderBuf, NrOfGroups, NrOfArticles;
extern UWORD OS_VER;
extern int GlobalERROR, MaxScrLines, MaxChars, defcomm, switches, rotnumber;
extern ULONG GeneralBool;   /* GeneralBoolean-Variable */
extern unsigned char casedep;    /* CASE INDEPENDENT for Match() */
extern struct kill_field *GlobalKill_List; /* Global Kill-List */
extern BOOL SubjectOrder, auxmode;

extern char *tmp,                    /* general tmp string SUPERLONG   */
     *moretmp,                /* needed for the pager SUPERLONG */
     *cmdline,                 /* Commandline-String */
     *fnametmp,                /* filename-String */
     *pathtogroup,             /* full path to group */
     *pathtodbase,             /* full path to dbasedir (variable len) */
     *nextcmd,                 /* Next command in cmdline, if any */
     *mBuffer,                 /* Multi-Purpose-Buffer */
     *HeaderBuf,               /* Header-Buffer */
     *newsgroup,
     *newsdir,                 /* arnconfig: news-dir */
     *dbasedir,                /* arnconfig: dbase-dir */
     *savedir,                 /* arnconfig: savedir */
     *activefile,              /* arnconfig: activefile */
     *grouplistfile,           /* arnconfig: name of .newsrc-file */
     *uuconfigfile,            /* arnconfig: name of uuconfigfile */
     *seqf,                    /* arnconfig: wheres the seq-nr for news? */
     quotechar[5],             /* arnconfig: quotechar */
     timez[6],                 /* arnconfig: timezone-name */
     *signfile,                /* arnconfig: where's the signature */
     *headerfile,              /* arnconfig: where's the headerfile */
     *replyto,                 /* arnconfig: special reply-address */
     *uuxname,                 /* arnconfig: which prg sends the news? */
     *sendmail,                /* arnconfig: which prg sends the mail? */
     *shellwin,                /* arnconfig: shell-window */
     *rnews,                   /* arnconfig: which prg gets the article? */
     *externprg,               /* arnconfig: external program */
     *filter,                  /* arnconfig: filter */
     *colordata,               /* arnconfig: custom colors */
     *headerline,              /* arnconfig: headerline string */
     *globalkillfile,          /* derived from grouplistfile */
     *AuxEditor,               /* arnconfig: editor in AUX:-mode */
     *MetaMail,                /* arnconfig: Metamail call */
     *PubScreenName,           /* arnconfig: PublicScreen Name */
     *NodeName,       /* from UUConfig */
     *NewsFeed,
     *DomainName,
     *UserName,
     *RealName,
     *OrgaName,
     *NewsEditor,
     *MailEditor,
     *Moderators;  /**** end UUConfig ****/

extern
struct search_struct /* Searchpattern for "/" */
{
  union pattern_union
  {
    regexp *regpat;  /* regular expression */
    char   *kmppat;  /* KMP expression */
  } pattern;
  short int *kmp_table; /* Array of ints that hold table values for KMP */
  int patlen;
} searchpat;

extern char *tc_BOLDFACE_ON,
     *tc_BOLDFACE_OFF,
     *tc_UNDERLINE_ON,
     *tc_UNDERLINE_OFF,
     *tc_SLANTED_ON,
     *tc_SLANTED_OFF,
     *tc_INV_ON,
     *tc_INV_OFF,
     *tc_GOTO_XY,
     *tc_CURSOR_UP,
     *tc_CURSOR_DOWN,
     *tc_CURSOR_LEFT,
     *tc_CURSOR_RIGHT,
     *tc_CLRSCR,
     *tc_CLR_TO_EOL,
     *tc_EOL,
     *tc_DELCHAR,
     *tc_INSCHAR,
     *tc_KEY_CURSOR_UP,
     *tc_KEY_CURSOR_DOWN,
     *tc_KEY_CURSOR_LEFT,
     *tc_KEY_CURSOR_RIGHT,
     *tc_KEY_DELCHAR,
     *tc_KEY_BACKSPACE,
     *EmphON,*EmphOFF; /* Emphasize Arn's Messages */

extern struct GroupInfoList *RootGI, *LastGroup;    /* structs are in includes.h */
extern struct art_struct *RootArt, *pArt, *LastArt;

extern char *ErrMsg[], *HeaderLines[];
extern long Translate[];

extern struct NewScreen ArnNewScreen;
extern struct NewWindow ArnNewWin;

/* end */
               /*************************************/
#endif
