/****************************************************************
 * includes.h - system includes and private structures for Arn  *
 * Arn - the Amiga-USENET newsreader                            *
 * (C)opyright 1990-92 by Roland Bless                          *
 * All rights reserved                                          *
 ****************************************************************/

#ifndef INCLUDES_SYM
#define INCLUDES_SYM
             /***********************************/
#include <stdio.h>
#ifdef AZTEC
 #undef BUFSIZ
 #define BUFSIZ 4096
#endif
#include <string.h>
#include <stdlib.h>
#ifdef __SASC
 #undef BUFSIZ
 #define BUFSIZ 4096
#endif
#include <ctype.h>
#ifndef INTUITION_INTUITION_H
 #include <intuition/intuition.h>
#endif
#ifndef LIBRARIES_DOSEXTENS_H
#include <libraries/dosextens.h>
#endif
#ifndef GRAPHICS_GFXBASE_H
 #include <graphics/gfxbase.h>
#endif

#include "regexp/regexp.h"

/* #ifndef STRPROCS_C
   #include "strprocs.c"
   #endif */

#include <proto/dos.h>
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>


#define MAXLINE 255            /* Maximal 256 Zeichen pro Zeile */
#define SUPERLINE 1024         /* Super-long line */
#define M_BUFFERSIZE 0x4000    /* Multi-purpose-buffer size: 16k */
#define SIZEOF_HEADERBUF 0x1000 /* Header-Buffer */
#define MEMTYPE NULL          /* Fast, Chip or whatever */
#define true 1                /* Boolean as int */
#define false 0
#define MAX_SELECT_LINES 78   /* Maximum selection lines */
#define MENU_OFFSET_1    26   /* First offset for extra selection */
#define OFFSET_1_CHAR    '.'  /* character to introduce 1st offset */
#define GROUPSEL 0            /* Command-Level */
#define ARTSEL  1
#define PAGER   2
#define ERROUT stdout         /* where to put the error-messages
                                 dont use stderr if you want to close the
                                 cli from where "Arn" was launched! */

#define ESC 0x1b
#define CSI 0x9b
#define BS '\x08'
#define CR '\x0D'
#define CLRL "\x9b\x4d"
#define DEFAULT_SUBJECTLEN_FOR_XFILES 32
#define TERMCAP_MAXSIZE 1024
#define CUNUM_UP    1
#define CUNUM_DOWN  2
#define CUNUM_LEFT  3
#define CUNUM_RIGHT 4

#define ctrl(ch) ((ch)&037)

                          /* System Functions */

extern void ErrorHandle(int ErrMsgNr, char *addinfo),
            DispMsg(char *text), ConCR(void), ClrLine(void),
            StatusLine(void), FreeString(char *string);

char        *CopyString(char *string);


struct Markers      /* single linked list for read marks in grouplist */
{
  char *Mark;               /* This is the string of ASCII-Ranges */
  int lastpos;              /* length of string Mark, Mark[lastpos]='\0' */
  struct Markers *NextMark; /* Next MarkString */
};

struct GroupInfoList    /* This is a structure for a double-linked list */
{                       /* of newsgroups */
  char                 *Name;         /* Name of the Group */
  struct Markers       *Marks;        /* The list of read articles */
  ULONG                firstArtNr;    /* First Article Number */
  ULONG                lastArtNr;     /* Last  Article Number */
  ULONG                OldlastArtNr;  /* Last Article Number from the last time */
  ULONG                UserlastArtNr; /* Last Article # last time user invoked arn */
  struct subj_struct   *RootSubjP; /* RootP of subject list */
  struct GroupInfoList *PrevGI;    /* Previous newsgroup */
  struct GroupInfoList *NextGI;    /* Next newsgroup */
  UWORD                Status;     /* Status word of this Newsgroup */
};


struct art_struct  /* Structure for a double linked list of articles */
{
  struct subj_struct *Subject;          /* Pointer to subject */
  struct art_struct  *PrevArt,*NextArt; /* Article thread */
  long               Lines;             /* number of lines, -1 means no lines available */
  ULONG              NrofFollowUps,     /* number of FollowUps */
                     Date,              /* Articles Date */
                     ArticleNr;         /* TO REMOVE!!! */
  void *ExtData;                        /* for future enhancements */
  UWORD Status;                         /* Article Status Flags */
  char *From;                           /* Pointer to author */
};


struct subj_struct /* Structure for a linked List of News */
{
  char               *Subject;     /* pointer to the subject itself */
  struct art_struct  *RootArt;     /* pointer to first article in thread */
  struct subj_struct *NextSubject; /* subject chain */
};


struct kill_strings
{
  regexp *regexp;                  /* pattern for regexp (compiled!) */
  char   *string;                  /* string pattern for normal matcher */
  struct kill_strings *nextstring; /* next pattern within this header-line */
  short int *table;                /* table for string-matcher */
  short int command;               /* command to execute if pattern matches */
  short int strlen;                /* string length for normal matcher */
  unsigned short int attributes;   /* attributes like case-sensitive, match begin */
};


struct kill_field
{
  char *headerline;                  /* pattern for field in header */
  struct kill_strings *stringlist;   /* pointer to stringlist (see above) */
  struct kill_field   *nextfield;    /* next pattern for headerfield */
};

             /***********************************/
#endif
