/* makeproto.c -  Extracts prototypes from files           */
/* all text between PROTO_START and PROTO_END is extracted */
/* (C)opyright by R.Bless                                  */

#include <stdio.h>
#include <strings.h>

char *PROTO_START="/* proto$start";
char *PROTO_END="/* proto$end";

char tmp[1024];
int start, proto_start_len,proto_end_len;
FILE *input,*output;

main(int argc, char **argv)
{
  start= 0;
  proto_start_len= strlen(PROTO_START);
  proto_end_len= strlen(PROTO_END);

  if (argc==1)
  {
    input=stdin;
    output=stdout;
  }
  else
  if (argc!=3)
  {
    printf("Usage: makeproto [infile] [outfile]\n");
    exit(0);
  }
  else
  {
    if((input= fopen(argv[1],"r"))==NULL)
    {
      printf("couldn't open input file: %s\n", argv[1]);
      exit(0);
    }
    else
    if((output= fopen(argv[2],"w"))==NULL)
    {
      printf("couldn't open output file: %s\n", argv[1]);
      exit(0);
    }
  }

  while(fgets(tmp,1023,input) && strncmp(tmp,PROTO_END,proto_end_len))
  {
    if (start)
       fputs(tmp,output);
    else
    if (start==0 && strncmp(tmp,PROTO_START,proto_start_len)==0)
       start=1;
  }

  if(input!=stdin) fclose(input);
  if(output!=stdout) fclose(output);
}
