                          /*** preprnews.c ***/
/*************************************************************************
 * preprnews.c - a program for feeding a single-raw article to rnews     *
 * (C)opyright by Roland Bless, written 4-Jun-1990/02-Sep1990            *
 *************************************************************************/

/* usage: preprnews articlename progname
   example preprnews T:tmpfoobar "rnews <"

   description:
   preprnews reads the article named "articlename" and cuts off the
   "Relay-Version:"/"Posting-Version:" lines, adds the "#! rnews XXXX"
   line and passes this new file (T:TMPXXXXXX) to the program "progname".
   Then the new (tmp)file is deleted.
   The NULL:-Device must be installed!!
*/

#include <stdio.h>

#include <proto/exec.h>
#include <proto/dos.h>

#undef BUFSIZ
#define BUFSIZ 4096

#define TMPSIZE 1024L


FILE *infp, *outfp;
long size;
char name[32], *tmp;
int c;


main(int argc,char **argv)
{
  fclose(stderr);
  tmp= AllocMem(TMPSIZE, NULL);

  if (!tmp)
  {
    printf("%s: Out of Memory-Error!\n",*argv);
    return 25;
  }

  sprintf(name,"T:TMP%lx",FindTask(NULL));
  if (argv[1])
     if (infp= fopen(argv[1],"r"))
     {
       fseek(infp, 0L, 2);
       size= ftell(infp);
       rewind(infp);
       c= fgetc(infp); /* skip relay-version, posting-version */
       if (c=='R')
       {
         fgets(tmp,1024, infp);
         fgets(tmp,1024, infp);
       }
       else
         rewind(infp);

       size-=ftell(infp);

       if (outfp= fopen(name,"w"))
       {
         fprintf(outfp, "#! rnews %ld\n",size);
         while ((c= fgetc(infp))!=EOF)
               fputc(c,outfp);
         fclose (outfp);
         if (argv[2])
         {
           sprintf(tmp, "%s %s",argv[2], name);
           Execute(tmp, NULL, NULL);
         }
         DeleteFile(name);
       }
       fclose(infp);
     }
     else
       printf("Cannot open: %s\n", argv[1]);

   if (tmp) FreeMem(tmp, TMPSIZE);
}
