/************************************************************************
 * reply.c -- reply function for arn                                    *
 *                                                                      *
 * Arn - (C)opyright by Roland Bless, All rights reserved,              *
 * -------- YOU ARE NOT ALLOWED TO DISTRIBUTE A CHANGED SOURCE -------- *
 *                                                                      *
 *  (C)opyright 1990-92 by Roland Bless of Blessed Software Products    *
 ************************************************************************/

#include <time.h>
#include <dos.h>

#ifndef GLOBALVARS_H
#include "globalvars.h"
#endif

#ifndef ENUMS_H
 #include "enums.h"
#endif

/* Prototypes for functions defined in reply.c */
/* proto$start */
void EditMail(char *MyTmp, BOOL dont_edit);
int Reply(ULONG ArticleNr, char *maddress, short mode);
void MailTo(char *address);
/* proto$end */

#include "proto/strprocs_proto.h"
#include "proto/pager_proto.h"
#include "proto/ArnIO_proto.h"
#include "proto/followup_proto.h"
#include "proto/functions_proto.h"
#include "proto/time_proto.h"
#ifdef LATTICE_50
 #include "proto/raw_proto.h"
#endif



extern char *pend, *HeaderBuf, *actual_pos;
extern char *mimefile;

                    /*************************/

void
EditMail(char *MyTmp, BOOL dont_edit)
/* MyTmp==Name of file to be edited! */
{
  BOOL titleset= false, wrongchar= false;
  long result= 0L, filedate= 0L;

  if (!(GeneralBool & SCREENTITLE))
  {
    ShowTitle(ArnScreen, TRUE);
    titleset= true;
  }

  AppendSignature(MyTmp);

  filedate= getft(MyTmp);

  /* if dont_edit=true don't call the editor the first time */
  do
  {
    if (!dont_edit)
    {
      DispMsg("invoking editor...");
      if (GeneralBool & EDSCRSWITCH)
         WBenchToFront();
      if (auxmode && AuxEditor)
        sprintf(tmp,"%s %s", AuxEditor, MyTmp);
      else
        sprintf(tmp,"%s %s", MailEditor, MyTmp);
      system(tmp);
      if (auxmode) rawcon(1);
      ScreenToFront(ArnScreen);
      ActivateWindow(ArnWin);
      DispMsg("ready.\n");

      if (getft(MyTmp)==filedate)
      {
        DispMsg("article not modified, aborted. ");
        *tmp= 'a';
        break;
      }
    }

    do
    {
      dont_edit= false;
      DispMsg("\ns)end, e)dit, a)bort:");
      ConClear();
      wrongchar= false;
      tmp[0]= (*GetKey)();
      ConCR();
      tmp[1]= '\0';
      if(strcspn(tmp,"sea"))
      {
        ClrLine();
        DispMsg("Wrong input. Try again.\n");
        wrongchar= true;
      }
    }
    while (wrongchar);
  }
  while (tmp[0]=='e');

  if (tmp[0]=='s')
  {
    DispMsg("Sending mail...");
    sprintf(tmp, sendmail, MyTmp);
    result= Execute(tmp,(BPTR) NULL,(BPTR) OutFH);
    if (auxmode) rawcon(1);
    DispMsg("ready.\n");
    if (result!=DOSTRUE)
    {
      DispMsg("Some trouble! Tmp-File is not deleted!\n");
      RenameTmpFile(MyTmp);
    }
    else
     DeleteFile(MyTmp);
  }
  else
  {
    DispMsg("mail not sent!\n");
    RenameTmpFile(MyTmp);
  }
  if (titleset) ShowTitle(ArnScreen, FALSE);
}


int
Reply(ULONG ArticleNr, char *maddress, short mode)
{
  FILE *OrigArt= NULL, *QArt= NULL;
  BOOL Error= false;
  char *subject, *refs, *MyTmp= NULL, *line;

  pend= NULL;

  if (mode==QUOTE)
   DispMsg("Quoting article...");
  else
  if (mode==FORWARD)
   DispMsg("Forwarding this article...\n");
  else
    DispMsg("Generating header...");

  OrigArt= NULL;

  if (mimefile)
  {
    strcpy(fnametmp,mimefile);
  }
  else
  {
    MakeDirName(tmp,newsdir,newsgroup);
    sprintf(fnametmp,"%s/%lu",tmp,ArticleNr);
  }

  OrigArt= fopen(fnametmp, "r");
  if (OrigArt)
  {
    while(fgets(tmp,SUPERLINE,OrigArt) && *tmp!='\n' );
  }
  else
    Error= true; /* Couldn't open original article! */

  if (!Error)
  {
    strcpy(tmp,"T:ARN1.XXXXXXXX.R");

    MyTmp= CopyString(mytmp(tmp));

    QArt= fopen(MyTmp, "w");
    if (QArt)
    {
      if (GeneralBool & GENFROMLINE)
         fprintf(QArt,"%s %s@%s%s (%s)\n", HeaderLines[HL_FROM],
                             UserName, NodeName, DomainName, RealName);

      if (mode!=FORWARD)
      {
        if (!maddress)
        {
          maddress= GetBufField_nwspc(HeaderLines[HL_REPLY_TO]);
          if (!maddress)
             maddress= GetBufField_nwspc("Return-Path:");
          if (!maddress)
             maddress= GetBufField_nwspc(HeaderLines[HL_FROM]);
        }
        fprintf(QArt,"To: %s\n", maddress);
        fprintf(QArt,"Cc:\nBcc:\n");

        fprintf(QArt,"%s ", HeaderLines[HL_SUBJECT]);
        subject= GetBufField_nwspc(HeaderLines[HL_SUBJECT]);
        if (!subject)
          subject= GetBufField_nwspc(HeaderLines[HL_TITLE]);   /* old format */

        if (!firststr(subject, "Re:") && !firststr(subject, "Re^"))
        {
          fprintf(QArt,"Re: ");
        }
        fprintf(QArt,"%s\n", subject);
        refs= GetBufField_nwspc(HeaderLines[HL_MESSAGE_ID]);
        if (!refs)
           refs= GetBufField_nwspc(HeaderLines[HL_ARTICLE_ID]);
        if (refs)
           fprintf(QArt,"In-Reply-To: %s; (%s)\n", refs, newsgroup);

      }
      else
      {
        DispMsg("To:");
        *tmp= '\0';
        Getline(tmp,255);ConCR();
        fprintf(QArt,"To: %s\n",tmp);
        DispMsg("Cc:");
        *tmp= '\0';
        Getline(tmp,255);ConCR();
        fprintf(QArt,"Cc: %s\n",tmp);
        DispMsg("Bcc:");
        *tmp= '\0';
        Getline(tmp,255);ConCR();
        fprintf(QArt,"Bcc: %s\n",tmp);
        fprintf(QArt,"%s FORWARDED article from %s\n", HeaderLines[HL_SUBJECT], newsgroup);
        ClrLine();
        DispMsg("generating mail...");
      }

      if (GeneralBool & GENDATELINE)
         fprintf(QArt,"%s %s\n", HeaderLines[HL_DATE], TimeStr(0));

      fprintf(QArt,"%s ", HeaderLines[HL_REPLY_TO]);
      if (replyto)
         fprintf(QArt,"%s\n", replyto);
      else
         fprintf(QArt,"%s@%s%s\n", UserName, NodeName, DomainName);
      if (OrgaName)
         fprintf(QArt,"%s %s\n\n", HeaderLines[HL_ORGANIZATION], OrgaName);
      else
         fputc('\n',QArt);

      if (mode==QUOTE)
      {
        refs= GetBufField_nwspc(HeaderLines[HL_MESSAGE_ID]);
        if (!refs)
           refs= GetBufField_nwspc(HeaderLines[HL_ARTICLE_ID]);

        if (refs)
           fprintf(QArt,"In %s, article %s, you wrote:\n\n", newsgroup, refs);
        while (fgets(tmp,SUPERLINE,OrigArt))
           fprintf(QArt,"%s%s",quotechar,tmp);
      }
      if (mode==FORWARD)
      {
        fprintf(QArt,"This is an article from %s,\nforwarded by %s <%s@%s%s>.\n",
                      newsgroup, RealName, UserName, NodeName, DomainName);
        fprintf(QArt,"\n------------- beginning of forwarded article -------------\n");
        GetBufField_nwspc(NULL); /* restore HeaderBuf */
        pend=NULL;
        actual_pos= HeaderBuf; /* Reset position */
        while (GetNextHeaderLine(&line))  /* QUOTE header */
          fprintf(QArt,"|%s\n",line);

        fputc('\n',QArt);        /* separate Header */
        GetNextHeaderLine(NULL); /* restore Buffer */
        pend= NULL;

        while (fgets(tmp,SUPERLINE,OrigArt))
           fprintf(QArt,"%s",tmp);           /* include original article */
        fprintf(QArt,"---------------- end of forwarded article ----------------\n");
      }
      else
      if (mode==NOQUOTE)
      {
        refs= GetBufField_nwspc(HeaderLines[HL_MESSAGE_ID]);
        if (!refs)
           refs= GetBufField_nwspc(HeaderLines[HL_ARTICLE_ID]);

        if (refs)
           fprintf(QArt,"This is a reply to your article %s in %s.\n", refs, newsgroup);
      }

      GetBufField_nwspc(NULL);
      fclose (QArt);
    }
  }
  if (OrigArt) fclose(OrigArt);

  EditMail(MyTmp, (mode==FORWARD) ? true : false);

  FreeString(MyTmp);

  return 0;
}


void
MailTo(char *address)
{
  FILE *Mail;
  char *MyTmp;

  strcpy(tmp,"T:ARN1.XXXXXXXX.R");

  MyTmp= CopyString(mytmp(tmp));
  Mail= fopen(MyTmp, "w");
  if (Mail)
  {
    if (GeneralBool & GENFROMLINE)
       fprintf(Mail,"%s %s@%s%s (%s)\n", HeaderLines[HL_FROM],
                           UserName, NodeName, DomainName, RealName);
    fprintf(Mail,"To: %s", address);
    DispMsg("Cc:");
    *tmp= '\0';
    Getline(tmp,255);ConCR();
    fprintf(Mail,"Cc: %s\n",tmp);
    DispMsg("Bcc:");
    *tmp= '\0';
    Getline(tmp,255);ConCR();
    fprintf(Mail,"Bcc: %s\n",tmp);
    DispMsg(HeaderLines[HL_SUBJECT]);
    *tmp= '\0';
    Getline(tmp,255);ConCR();
    fprintf(Mail,"%s %s\n",HeaderLines[HL_SUBJECT], tmp);

    if (GeneralBool & GENDATELINE)
       fprintf(Mail,"%s %s\n", HeaderLines[HL_DATE], TimeStr(0));

    fprintf(Mail,"%s ", HeaderLines[HL_REPLY_TO]);
    if (replyto)
       fprintf(Mail,"%s\n", replyto);
    else
       fprintf(Mail,"%s@%s%s\n", UserName, NodeName, DomainName);
    if (OrgaName)
       fprintf(Mail,"%s %s\n\n", HeaderLines[HL_ORGANIZATION], OrgaName);
    else
       fputc('\n',Mail);

    fclose(Mail);
  }
  EditMail(MyTmp, false);
}
