#define TZ_A    0x00000020L
#define TZ_ADT  0x00009280L /* -03     Atlantic Daylight Time */
#define TZ_AHST 0x00144e80L /* -10     Alaska-Hawaii Standard Time */
#define TZ_AKDT 0x00159280L /* -08     Alaska Daylight */
#define TZ_AKST 0x0015ce80L /* -09     Alaska Standard */
#define TZ_AST  0x0000ce80L /* -04     Atlantic Standard Time */
#define TZ_AT   0x00000680L /* -02     Azores Time */
#define TZ_B    0x00000040L
#define TZ_BST  0x00014e80L /* +01     British Summer Time */
#define TZ_BT   0x00000a80L /* -11     "Bering Time" */
#define TZ_C    0x00000060L
#define TZ_CADT 0x00309280L /* +10.5   Central Australian Daylight Time */
#define TZ_CAST 0x0030ce80L /* +09.5   Central Australian Standard Time */
#define TZ_CAT  0x00018680L /* -10     Central Alaska Time */
#define TZ_CCT  0x00018e80L /* +08     China Coast Time, USSR Zone 7 */
#define TZ_CDT  0x00019280L /* -05     Central Daylight Time */
#define TZ_CEDT 0x00329280L /* +02     "Central European Daylight Time" */
#define TZ_CES  0x00019660L /* +02     "Central European Summer time" */
#define TZ_CEST 0x0032ce80L /* +02     Central European Summer Time */
#define TZ_CET  0x00019680L /* +01     Central European Time */
#define TZ_CST  0x0001ce80L /* -06     Central Standard Time */
#define TZ_CUT  0x0001d680L /* 00      Coordinated Universal */
#define TZ_D    0x00000080L
#define TZ_E    0x000000a0L
#define TZ_EADT 0x00509280L /* +11     East Australian Daylight Time */
#define TZ_EAST 0x0050ce80L /* +10     East Australian Standard Time */
#define TZ_ECT  0x00028e80L /* +01     "European Central Time"? (Norway) */
#define TZ_EDT  0x00029280L /* -04     Eastern Daylight Time */
#define TZ_EET  0x00029680L /* +02     Eastern European Time, USSR Zone 1 */
#define TZ_EST  0x0002ce80L /* -05     Eastern Standard Time */
#define TZ_F    0x000000c0L
#define TZ_FST  0x00034e80L /* +02     French Summer Time */
#define TZ_FWT  0x00035e80L /* +01     French Winter Time */
#define TZ_G    0x000000e0L
#define TZ_GMT  0x0003b680L /* +00     Greenwich Mean Time */
#define TZ_GST  0x0003ce80L /* -03     Greenland Standard Time */
#define TZ_GVA  0x0003d820L /* +01     ? (Switzerland) */
#define TZ_H    0x00000100L
#define TZ_HADT 0x00809280L /* -09     Hawaii-Aleutian Daylight */
#define TZ_HAST 0x0080ce80L /* -10     Hawaii-Aleutian Standard */
#define TZ_HFE  0x000418a0L /* +02     Heure Francais d'Ete */
#define TZ_HFH  0x00041900L /* +01     Heure Francais d'Hiver */
#define TZ_HKT  0x00042e80L /* +08     Hong Kong */
#define TZ_HST  0x00044e80L /* -10 Hawaii Standard */
#define TZ_I    0x00000120L
#define TZ_IDLE 0x009230a0L /* +12     International Date Line, East */
#define TZ_IDLW 0x009232e0L /* -12     INternational Date Line, West */
#define TZ_IST  0x0004ce80L /* +02     Israelian Standard Time */
#define TZ_IT   0x00002680L /* +03.5   Iran Time */
#define TZ_J    0x00000140L /* not used! */
#define TZ_JST  0x00054e80L /* +09     Japan Std Time, USSR Zone 8 */
#define TZ_JT   0x00002a80L /* +07.5   Java Time */
#define TZ_K    0x00000160L
#define TZ_KDT  0x00059280L /* +10     Korean Daylight */
#define TZ_KST  0x0005ce80L /* +09     Korean Standard */
#define TZ_L    0x00000180L
#define TZ_M    0x000001a0L
#define TZ_MDT  0x00069280L /* -06     Mountain Daylight Time */
#define TZ_MEST 0x00d2ce80L /* +02     Middle European Summer Time */
#define TZ_MESZ 0x00d2cf40L /* +02     "Mittel Europaeische Sommer Zeit" (G */
#define TZ_MET  0x00069680L /* +01     Middle European Time */
#define TZ_MEWT 0x00d2de80L /* +01     Middle European Winter Time */
#define TZ_MEZ  0x00069740L /* +01     "Mittel Europaeische Zeit" (Germany) */
#define TZ_MSD  0x0006cc80L /* +04     Moskow Summer */
#define TZ_MSK  0x0006cd60L /* +03     Moskow Winter */
#define TZ_MST  0x0006ce80L /* -07     Mountain Standard Time */
#define TZ_MT   0x00003680L /* +08.5   Moluccas Time */
#define TZ_N    0x000001c0L
#define TZ_NDT  0x00071280L /* -02.5   Newfoundland Daylight Time */
#define TZ_NST  0x00074e80L /* -03.5   Newfoundland Standard Time */
#define TZ_NT   0x00003a80L /* -11     Nome Time */
#define TZ_NZDT 0x00ed1280L /* +13     New Zealand Daylight Time */
#define TZ_NZST 0x00ed4e80L /* +12     New Zealand Standard Time */
#define TZ_NZT  0x00076a80L /* +12     "New Zealand Time" */
#define TZ_O    0x000001e0L
#define TZ_P    0x00000200L
#define TZ_PDT  0x00081280L /* -07     Pacific Daylight Time */
#define TZ_PST  0x00084e80L /* -08     Pacific Standard Time */
#define TZ_Q    0x00000220L
#define TZ_R    0x00000240L
#define TZ_S    0x00000260L
#define TZ_SADT 0x01309280L /* +10.5   South Australian Daylight Time */
#define TZ_SAST 0x0130ce80L /* +09.5   South Australian Standard Time */
#define TZ_SET  0x00099680L /* +01     "Standard European Time" */
#define TZ_SST  0x0009ce80L /* +02     "Swedish Summer Time" */
#define TZ_SWT  0x0009de80L /* +01     "Swedish Winter Time" */
#define TZ_T    0x00000280L
#define TZ_U    0x000002a0L
#define TZ_UT   0x00005680L /* +00     Universal Time */
#define TZ_UTC  0x000ad060L /* +00     Universal Time, coordinated */
#define TZ_V    0x000002c0L
#define TZ_W    0x000002e0L
#define TZ_WADT 0x01709280L /* +08     West Australian Daylight Time */
#define TZ_WAST 0x0170ce80L /* +07     West Australian Standard Time */
#define TZ_WAT  0x000b8680L /* -01     West Africa Time */
#define TZ_WET  0x000b9680L /* +00     Western European Time */
#define TZ_WZ   0x00005f40L /* +00     "Weltzeit" */
#define TZ_X    0x00000300L
#define TZ_Y    0x00000320L
#define TZ_YDT  0x000c9280L /* -08     Yukon Daylight */
#define TZ_YST  0x000cce80L /* -09     Yukon Standard Time */
#define TZ_Z    0x00000340L /* +00     Universal Time */
