
/*
 *  DATABASE.H
 */

typedef long record_t;

typedef struct DBHead {     /*	ROOT (invisible)        */
    long    db_Version;
    long    db_Endian;	    /*	db_Endian=0x01020304	*/
    long    db_Reserved;
    long    db_SubTree;
} DBHead;


typedef struct DBRecord {
    long    dr_Type;	    /*	record type (< 0 == deleted)        */
    long    dr_Size;	    /*	record size (not including header)  */
    long    dr_Chain;	    /*	chain link			    */
    long    dr_SubTree;     /*	subtree offset			    */
} DBRecord;

typedef struct DBHan {
    Node    db_Node;
    void    *db_Fi;
    DBHead  db_Head;
    DBRecord db_Record;     /*	record cache	    */
    record_t db_RId;	    /*	record id, cache    */

    record_t db_AppRoot;    /*	cache for appending */
    record_t db_AppLast;
} DBHan;

