
/*
 *  PUT.C
 */

#include "defs.h"

Prototype void PutBMS(char *, char *);
Prototype void SMPutNoChannel(DBHan *, record_t, RegNode *, long);
Prototype void InitPut(void);

void
InitPut(void)
{
}

/*
 *  PUT a file/directory to a destination
 *
 */

void
PutBMS(locFileName, remFileName)
char *locFileName;
char *remFileName;
{
    RegNode *rn;
    CtlNode *cn;
    FileNode *fn;

    if ((rn = FindFirstMarked()) == NULL || rn->rn_Node.ln_Name) {
	bmslog("Put", "No destination specified");
	return;
    }
    if (rn->rn_Comm.com_DID == 0) {
	bmslog("Put", "Registration for this destination is still in progress");
	bmslog("Put", "Request will be initiated after registration is complete");
    }

    /*
     *	Allocate node and initiate communications.  Can setup FileNode
     *	after communications has been initiated
     */

    cn = AllocCtlNode(rn);
    InitCommLocalSide(SMACH_PUT, rn, &cn->cn_Comm);

    /*
     *	Allocate and setup a FileNode.	File will be broken up into chunks
     *	by the communications state machine
     */

    fn = AllocFileNode(cn);
    if (remFileName)
	fn->fn_RemFileName = zstrdup(remFileName);
    if (locFileName)
	fn->fn_LocFileName = zstrdup(locFileName);
}



void
SMPutNoChannel(db, rid, rn, did)
DBHan *db;
record_t rid;
RegNode *rn;
long did;
{
}


