
/*
 *  VAR.C
 */

#include "defs.h"

Prototype void ModifyVariables(void);

/*
 *  Modify variables associated with marked nodes
 */

void
ModifyVariables()
{
    RegNode *rn;

    if (MaxRxBpd || MaxTxBpd || MaxRxBpw || MaxTxBpw || MaxRxMail ||
	MaxTxMail || MinMail || MirRxBpd || MirTxBpd || CacBwPerc ||
	ReqSwamp || MirSwamp)
    {
	for (rn = GetHead(&RegList); rn; rn = GetSucc(&rn->rn_Node)) {
	    if (rn->rn_Flags & GF_MARKED) {
		if (MaxRxBpd)
		    rn->rn_Param.pm_MaxRxBpd = MaxRxBpd;
		if (MaxTxBpd)
		    rn->rn_Param.pm_MaxTxBpd = MaxTxBpd;
		if (MaxRxBpw)
		    rn->rn_Param.pm_MaxRxBpw = MaxRxBpw;
		if (MaxTxBpw)
		    rn->rn_Param.pm_MaxTxBpw = MaxTxBpw;
		if (MaxRxMail)
		    rn->rn_Param.pm_MaxRxMail = MaxRxMail;
		if (MaxTxMail)
		    rn->rn_Param.pm_MaxTxMail = MaxTxMail;
		if (MinMail)
		    rn->rn_Param.pm_MinMail = MinMail;
		if (MirRxBpd)
		    rn->rn_Param.pm_MirRxBpd = MirRxBpd;
		if (MirTxBpd)
		    rn->rn_Param.pm_MirTxBpd = MirTxBpd;
		if (CacBwPerc)
		    rn->rn_Param.pm_CacBwPerc = CacBwPerc;
		if (ReqSwamp)
		    rn->rn_Param.pm_ReqSwamp = ReqSwamp;
		if (MirSwamp)
		    rn->rn_Param.pm_MirSwamp = MirSwamp;
		rn->rn_Flags |= GF_MODIFIED;
		rn->rn_Param.pm_Flags |= GF_MODIFIED;
	    }
	}
    }
}

