#include "prefs.h"
#include "time.h"

Prototype void CreateHeader(FILE*,char*,char*);
Prototype BOOL SetFolderName(char *);
Prototype FILE *OpenHomeBox(void);
Prototype void CloseHomeBox(FILE *);
Prototype char *plural_s(int);
Prototype int plural_pix(int);
Prototype int send_off(char *,char *);
Prototype void append_sig(FILE *);
Prototype void append_elmheader(FILE *);
Prototype void set_options(void);
Prototype void Init_Incoming(void);
Prototype void Free_Incoming(void);
Prototype void outline(void);
Prototype void OpenTTY(void);
Prototype void Usage(void);
Prototype void DirectSend(char *,char *);
Prototype void copy_and_do_from(FILE *,FILE *);
Prototype void str_replace(char *,char *,char *);
Prototype void do_introduction(FILE *,char *,MItem *);
Prototype void clean_exit(int);
Prototype void status_msg(char *, long);



void
CreateHeader(FILE* fp,char* To, char* Subject)
{
  fprintf(fp,"To: %s\n",STR(To));
  fprintf(fp,"Subject: %s\n",STR(Subject));
}



BOOL
SetFolderName(char *file)
{
  char *foldername;
  FILE *fp;

  if (file && strlen(file) && (foldername=malloc(strlen(file)+1))) {
    strcpy(foldername,file);
    /* IMHO it's not neccessary to lock the folder here */
    if (fp=fopen(foldername,"r")) {
      fclose(fp);
      if (FolderName) free(FolderName);
      FolderName = foldername;
      return(TRUE);
    }
    free(foldername);
  }

  return(FALSE);
}



FILE *OpenHomeBox(void)
{
  LockFile(FolderName);
  return(fopen(FolderName,"r"));
}



void CloseHomeBox(FILE *folder)
{
  fclose(folder);
  UnLockFile(FolderName);
}



/* send_off schickt die Mail in file ab, wenn die Abfrage mit 'S' */
/* beantwortet wurde. Der Returnwert ist 1, wenn die Mail versandt */
/* 2, wenn noch mals editiert werden soll und 0 wenn abgebrochen werden */
/* soll */

int send_off(char *file, char *in_reply_to)
{
  FILE *in,*out;
  char c;
  char String[MAX_LINELENGTH];
  char *tfile;
  BOOL display_header = TRUE;

  /* complete header - begin */

  if (tfile=malloc(strlen(file)+3)) {         /* len + ".o" + null */
    strcpy(tfile,file);
    strcat(tfile,".o");
    remove(tfile);
    rename(file,tfile);
    remove(file);
    if (out=fopen(file,"w")) {
      if (SendmailVersion==SM_FEULNER)
        fprintf(out,"From: %s@%s%s (%s)\n",UserName,NodeName,DomainName,RealName);
      if (in_reply_to)
        fprintf(out,"In-Reply-To: %s\n",in_reply_to);
      if (WantReturn)
        fprintf(out,"Return-Receipt-To: %s@%s%s\n",UserName,NodeName,DomainName);
      append_elmheader(out);
      if (in=fopen(tfile,"r")) {
        copy_and_do_from(in,out);
        fclose(in);
      }
      fclose(out);
      remove(tfile);
    }
  }

  /* complete header - end */

  while (TRUE) {

    if (display_header) {
      sprintf(TBuffer,"\033[%d;1H\033[J",Win_Height-1);
      outline();
      putst("And now: \n");
      putst("      Choose e)dit message, s)end, S)end without signature, or f)orget.");
      sprintf(TBuffer,"\033[%d;10H",Win_Height-1);
      outline();
      display_header = FALSE;
    }

    c=getch();
    if (toupper(c)=='S') {
      putst("Send");

      if (c=='s') {
        if (out=fopen(file,"a")) {
          append_sig(out);
          fclose(out);
        }
      }
      else
        putst(" (without signature)");

      if (in=fopen(file,"r")) {
        if (SentArchive) {
          if (out=fopen(SentArchive,"a")) {
            long t;
            time(&t);
            fprintf(out,"From %s (ARCHIVE)\n",UserName);
            fprintf(out,"Date: %s",ctime(&t));
            if (SendmailVersion!=SM_FEULNER)
              fprintf(out,"From: %s@%s%s (%s)\n",UserName,NodeName,DomainName,RealName);
            copy_and_do_from(in,out);
            fclose(out);
          }
        }
        fclose(in);
      }

      if (SendmailVersion==SM_FEULNER)
        sprintf(String,"sendmail <%s",file);
      else if (SendmailVersion==SM_DILLON)
        sprintf(String,"sendmail <%s -f %s -R \"%s\"",file,UserName,RealName);
      else if (SendmailVersion==SM_OTHER)
        sprintf(String,"sendmail <%s -f %s",file,UserName);

      Execute(String,0L,0L);
      return 1;
    }
    else if (c=='e') {
      putst("Edit message");
      editfile(file);
      display_header = TRUE;
    }
    else if (c=='f') {
      putst("Forget");
      return 0;
    }
  }
}



void
copy_and_do_from(FILE *in,FILE *out)
{
  char buf[MAX_LINELENGTH];
  buf[MAX_LINELENGTH-1]='\0';   /* 100% null-terminated */
  while(fgets(buf,MAX_LINELENGTH-1,in)) {
    if (strncmp("From ",buf,5)==0)
      fprintf(out,">%s",buf);
    else
      fputs(buf,out);
  }
}



void
append_elmheader(FILE *file)
{
  FILE *in;
  char *headerfile;

  if (headerfile = malloc(strlen(UULIB)+strlen(UserName)+strlen(ELM_HEADERS)+1)) {

    strcpy(headerfile,UULIB);
    strcat(headerfile,UserName);
    strcat(headerfile,ELM_HEADERS);

    if (!(in=fopen(headerfile,"r"))) {
      strcpy(headerfile,UULIB);
      strcat(headerfile,ELM_HEADERS);
      in=fopen(headerfile,"r");
    }

    fprintf(file,"X-Mailer: //\\\\miga Electronic Mail (AmiElm %s)\n",VERSION);

    if (in) {
      char line[MAX_LINELENGTH];
      line[MAX_LINELENGTH-1]='\0';
      while(fgets(line,MAX_LINELENGTH-1,in))
        if (strlen(line) && strchr(line,':'))
          fputs(line,file);
      fclose(in);
    }

    free(headerfile);
  }
}



void
append_sig(FILE *file)
{
  FILE *in;
  char *sigfile;

  if (sigfile = malloc(strlen(UULIB)+strlen(UserName)+strlen(SIGNATURE)+1)) {

    strcpy(sigfile,UULIB);
    strcat(sigfile,UserName);
    strcat(sigfile,SIGNATURE);

    if (!(in=fopen(sigfile,"r"))) {
      strcpy(sigfile,UULIB);
      strcat(sigfile,SIGNATURE);
      in=fopen(sigfile,"r");
    }

    if (in) {
      register int c;
      while((c=getc(in))!=EOF)
        putc(c,file);
      fclose(in);
    }

    free(sigfile);
  }
}



void
set_options(void)
{
  char c;
  BOOL Quit = FALSE;

  while(!Quit) {
    putst("\f\033[2;32H\033[1m O p t i o n s \033[0m");
    putst("\033[3;32H\033[1m_______________\033[0m");
    putst("\033[8;1HWhich option do you want to change (toggle) ?\n");
    putst(" (caution, changes are temporary!)\n\n\n");

    putst("   (1)  Handle Return-Receipt-To     (");
    if (ReturnReceipt)
      putst("on)\n");
    else
      putst("off)\n");

    putst("   (2)  Handle Return-\033[1mView\033[m-To        (");
    if (ReturnView)
      putst("on)\n");
    else
      putst("off)\n");

    putst("   (3)  Request Return-Receipt-To    (");
    if (WantReturn)
      putst("on)\n");
    else
      putst("off)\n");

    putst("   (4)  Request Return-\033[1mView\033[m-To       (");
    if (WantReturn)
      putst("on)\n");
    else
      putst("off)\n");

    putst("   (5)  Show full header             (");
    if (ShowHeader)
      putst("on)\n");
    else
      putst("off)\n");

    putst("   (6)  Show signatures              (");
    if (ShowSig)
      putst("on)\n");
    else
      putst("off)\n");

    putst("   (7)  Keep backups                 (");
    if (KeepBackup)
      putst("on)\n");
    else
      putst("off)\n");

    putst("\n\n\n Choose 1-7, or any other key to return: ");
    c=getch();
    switch (c) {
      case '1': ReturnReceipt = !ReturnReceipt; break;
      case '2': ReturnView    = !ReturnView;    break;
      case '3': WantReturn    = !WantReturn;    break;
      case '4': WantView      = !WantView;      break;
      case '5': ShowHeader    = !ShowHeader;    break;
      case '6': ShowSig       = !ShowSig;       break;
      case '7': KeepBackup    = !KeepBackup;    break;
      default : Quit          = TRUE;           break;
    }
  }
}



void
Init_Incoming(void)
{
  register int i;

  for (i=0;i<MaxMails;i++) {
    Incoming[i].Status         = 0;
    Incoming[i].Urgent         = 0;
    Incoming[i].ArtikelStart   = 0L;
    Incoming[i].ArtikelEnd     = 0L;
    Incoming[i].TextStart      = 0L;
    Incoming[i].SignatureStart = 0L;
    Incoming[i].Lines          = 0L;
    Incoming[i].TotalLines     = 0L;
    Incoming[i].Cc             = NULL;
    Incoming[i].Bcc            = NULL;
    Incoming[i].RV_To          = NULL;
    Incoming[i].RR_To          = NULL;
    Incoming[i].MessageID      = NULL;
    Incoming[i].From           = NULL;
    Incoming[i].FromName       = NULL;
    Incoming[i].To             = NULL;
    Incoming[i].ToName         = NULL;
    Incoming[i].ReplyTo        = NULL;
    Incoming[i].Subject        = NULL;
    Incoming[i].Date           = NULL;
  }
}



void
Free_Incoming(void)
{
  register int i;

  for (i=0;i<MaxMails;i++) {
    Incoming[i].Status         = 0;
    Incoming[i].Urgent         = 0;
    Incoming[i].ArtikelStart   = 0L;
    Incoming[i].ArtikelEnd     = 0L;
    Incoming[i].TextStart      = 0L;
    Incoming[i].SignatureStart = 0L;
    Incoming[i].Lines          = 0L;
    Incoming[i].TotalLines     = 0L;
    if (Incoming[i].Cc)        free(Incoming[i].Cc);
    if (Incoming[i].Bcc)       free(Incoming[i].Bcc);
    if (Incoming[i].RV_To)     free(Incoming[i].RV_To);
    if (Incoming[i].RR_To)     free(Incoming[i].RR_To);
    if (Incoming[i].MessageID) free(Incoming[i].MessageID);
    if (Incoming[i].From)      free(Incoming[i].From);
    if (Incoming[i].FromName)  free(Incoming[i].FromName);
    if (Incoming[i].To)        free(Incoming[i].To);
    if (Incoming[i].ToName)    free(Incoming[i].ToName);
    if (Incoming[i].ReplyTo)   free(Incoming[i].ReplyTo);
    if (Incoming[i].Subject)   free(Incoming[i].Subject);
    if (Incoming[i].Date)      free(Incoming[i].Date);
  }

  Init_Incoming();
}



/* Lowlevelroutinen zur Behandlung eines RAW-Fensters. Damit wird die
 * Eingabepufferung der Standard-C Routinen umgangen; ausserdem koennen
 * so die Cursortasten vom Programm aus abgefragt werden
 */

void
OpenTTY(void)
{
    if (!open_intuition()) {
      fprintf(stderr,"elm: cannot open tty\n");
      clean_exit(103);
    }
}



void
outline(void)
{
  putst(TBuffer);
}



/* Die naechste Prozedur gibt eine kleine Bedienungsanleitung auf dem
 * Bildschirm aus und verlaesst das Programm dann
 */
void
Usage(void)
{
    printf("\033[1;33mAmiga Elm \033[0m%s  1991 Andreas M. Kirchwitz (amk@zikzak.in-berlin.de)\n",VERSION);
    printf("(original source by Heiko W. Rupp, hwr@pilhuhn.ka.sub.org)\n");
    printf("Usage: elm \033[3m[?|-v|-h|-?|-f] [<user>] [-s <subject>]\033[0m\n");
    clean_exit(0);
}



void
DirectSend(char *To,char *Subject)
{
    OpenTTY();
    sendmail(To,Subject);
    clean_exit(0);
}



char *
plural_s(int number)
{
  return( (number==1)?"":"s" );
}



int
plural_pix(int number)
{
  return( (number==1)?1:0 );
}



void
str_replace(char *workbuf, char *search, char *replace)
{
  char *p;

  if (replace && strlen(replace) && (p=strstr(workbuf,search))) {
    char *s = p+strlen(search);
    char *d = p;

    while (*d++=*s++)
      ;

    strins(p,replace);
  }
}



void do_introduction(FILE *out, char *intro, MItem *I)
{
  int nnum;
  char *str;
  char *fname = NULL;

  if (intro && strlen(intro)) {
    if (I->FromName) {
      fname=malloc(strlen(I->FromName)+1);
      for(nnum=0;I->FromName[nnum]!='\0' && I->FromName[nnum]!=' ';nnum++)
        fname[nnum]=I->FromName[nnum];
      fname[nnum]='\0';
    }

    if (str=malloc(strlen(intro)+2*strlen(I->FromName)+strlen(I->MessageID)+strlen(I->Date)+1)) {
      strcpy(str,intro);
      str_replace(str,"$FIRSTNAME",fname);
      if (I->FromName && strlen(I->FromName))
        str_replace(str,"$NAME",I->FromName);
      else
        str_replace(str,"$NAME",I->From);
      str_replace(str,"$MSGID",I->MessageID);
      str_replace(str,"$DATE",I->Date);
      fprintf(out,"%s\n\n",str);
    }
  }
}



void clean_exit(int err_code)
{
  close_intuition();
  if (MailTmp) remove(MailTmp);
  UnLockFiles();
  exit(err_code);
}



void status_msg(char *msg, long delay_time)
{
  int hpos;
  if (intui_interface()) {
    hpos = (Win_Width-strlen(msg))/2;
    if (hpos<0)
      hpos=0;
    sprintf(TBuffer,"\033[%d;1H\033[J\033[%d;%dH[%.*s]",Win_Height,Win_Height,hpos-1,Win_Width-2,msg);
    outline();
    if (delay_time>0L)
      Delay(delay_time);
  }
  else
    fprintf(stderr,"elm: %s\n",msg);
}

