#include "prefs.h"
#ifdef LATTICE
#include <dos.h>
#endif
#ifdef DICE
#include <libraries/dos.h>
#endif


Prototype BOOL getline(FILE *,char *,long *);
Prototype void removeCR(char *);
Prototype long read_home_box(void);
Prototype BOOL get_config_entries(void);
Prototype char *firstnwsp(char *);



struct FlagItem {
  char *MsgID;
  StatusFlag Stat;
};



long
read_home_box(void)
{
    FILE *fp;
    MItem I;
    char Line[MAX_LINELENGTH];
    register char *ptr;
    char **last_data = NULL;
    char *p;
    register int i=0,c;
    long len,pos;
    BOOL InHeader = FALSE;
    static BOOL FirstAccess = TRUE;
    static struct FlagItem *flgs;
    static int OldMaxArticle = 0;
    char TitleString[1024];

#ifdef DEBUG
      fprintf(stderr,"read_home_box: %s\n",FolderName);
#endif

    if (FirstAccess) {
#ifdef DEBUG
      fprintf(stderr," first attempt to read folder\n");
#endif
      OldMaxArticle = 0;
      FirstAccess = FALSE;
      flgs = NULL;
    }
    else {
      int i;
#ifdef DEBUG
      fprintf(stderr," keep old msg-ids");
#endif
      if (flgs) {
#ifdef DEBUG
        fprintf(stderr,", clear old");
#endif
        for(i=0;i<OldMaxArticle;i++) {
          if (flgs[i].MsgID)
            free(flgs[i].MsgID);
        }
        free(flgs);
#ifdef DEBUG
        fprintf(stderr," (ok)");
#endif
      }
      if (flgs=malloc(MaxArticle*sizeof(struct FlagItem))) {
#ifdef DEBUG
        fprintf(stderr,", save new");
#endif
        OldMaxArticle = MaxArticle;
        for(i=0;i<MaxArticle;i++) {
          if (flgs[i].MsgID = malloc(strlen(Incoming[i].MessageID)+1)) {
            strcpy(flgs[i].MsgID,Incoming[i].MessageID);
            flgs[i].Stat = Incoming[i].Status;
          }
        }
#ifdef DEBUG
        fprintf(stderr," (ok)");
#endif
      }
#ifdef DEBUG
      fprintf(stderr,"\n");
#endif
    }

    Free_Incoming();
    MaxArticle=0;

    if ((fp=OpenHomeBox())==NULL)
        return(0L);

    while (getline(fp,Line,&pos)) {
#ifdef DEBUG
/*      fprintf(stderr," line: %s\n",Line);*/
#endif
      if (InHeader) {
        Incoming[i].TotalLines++;
        if (!Incoming[i].From && !strnicmp(Line,"From:",5)) {
            ptr=Line+5;
            while (*ptr==' ') ptr++;
            if (Incoming[i].From=malloc(strlen(ptr)+1))
              strcpy(Incoming[i].From,ptr);
            Incoming[i].FromName=NULL;
            if (p=strchr(ptr,'(')) { /* Name wird in '(' eingeschlossen */
              p++;
              if (p!=strchr(ptr,')')) {/* Ausdruck in den Klammern ist nicht leer */
                if (Incoming[i].FromName=malloc(strlen(p)+1)) {
                  strcpy(Incoming[i].FromName,p);
                  *(strchr(Incoming[i].FromName,')'))='\0';
                }
              }
            }
            else if (p=strchr(ptr,'<')) { /* Name steht davor */
              if (p!=ptr) {
                if (*ptr=='\"') ptr++;
                if (Incoming[i].FromName=malloc(strlen(ptr)+1)) {
                  strcpy(Incoming[i].FromName,ptr);
                  p=strchr(Incoming[i].FromName,'<');
                  do { p--; } while ((p>Incoming[i].FromName) && (*p=='\t' || *p==' ' || *p=='\"'));
                  p++;
                  *p='\0';
                }
              }
            }
            last_data = NULL;
        }
        else if (!Incoming[i].MessageID && !strnicmp(Line,"Message-Id:",11)) {
            ptr=Line+11;
            while (*ptr==' ') ptr++;
            if (Incoming[i].MessageID=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].MessageID,ptr);
              last_data = &Incoming[i].MessageID;
            }
            else
              last_data = NULL;
        }
        else if (!Incoming[i].Cc && !strnicmp(Line,"Cc:",3)) {
            ptr=Line+3;
            while (*ptr==' ') ptr++;
            if (Incoming[i].Cc=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].Cc,ptr);
              last_data = &Incoming[i].Cc;
            }
            else
              last_data = NULL;
        }
        else if (!Incoming[i].Bcc && !strnicmp(Line,"Bcc:",4)) {
            ptr=Line+4;
            while (*ptr==' ') ptr++;
            if (Incoming[i].Bcc=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].Bcc,ptr);
              last_data = &Incoming[i].Bcc;
            }
            else
              last_data = NULL;
        }
        else if (!Incoming[i].Date && !strnicmp(Line,"Date:",5)) {
            register char *p;
            ptr=Line+5;
            while (*ptr==' ') ptr++;
            if (*ptr<'0' || *ptr>'9') {           /* if exists name of day, */
              while (*ptr!=' ')                   /* skip it */
                ptr++;
            }
            while (*ptr==' ')                     /* skip spaces */
              ptr++;
            p=ptr;
            while (*p!=' ')                       /* skip day */
              p++;
            while (*p==' ')                       /* skip spaces */
              p++;
            while (*p!=' ')                       /* skip month */
              p++;
            *p='\0';
            if (Incoming[i].Date=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].Date,ptr);
              if (Incoming[i].Date[2]==' ') {    /* e.g. "13 Aug" */
                Incoming[i].Date[2]=Incoming[i].Date[5];
                Incoming[i].Date[5]=Incoming[i].Date[1];
                Incoming[i].Date[1]=Incoming[i].Date[4];
                Incoming[i].Date[4]=Incoming[i].Date[0];
                Incoming[i].Date[0]=Incoming[i].Date[3];
                Incoming[i].Date[3]=' ';
              }
              else if (Incoming[i].Date[1]==' ') {    /* e.g. "7 Sep" */
                Incoming[i].Date[1]=Incoming[i].Date[3];
                Incoming[i].Date[3]=Incoming[i].Date[0];
                Incoming[i].Date[0]=Incoming[i].Date[2];
                Incoming[i].Date[2]=Incoming[i].Date[4];
                Incoming[i].Date[4]=Incoming[i].Date[3];
                Incoming[i].Date[3]=' ';
              }
            }
            last_data = NULL;
        }
        else if (!Incoming[i].RR_To && !strnicmp(Line,"Return-Receipt-To:",18)) {
            ptr=Line+18;
            while (*ptr==' ') ptr++;
            if (Incoming[i].RR_To=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].RR_To,ptr);
              last_data = &Incoming[i].RR_To;
            }
            else
              last_data = NULL;
        }
        else if (!Incoming[i].RV_To && !strnicmp(Line,"Return-View-To:",15)) {
            ptr=Line+15;
            while (*ptr==' ') ptr++;
            if (Incoming[i].RV_To=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].RV_To,ptr);
              last_data = &Incoming[i].RV_To;
            }
            else
              last_data = NULL;
        }
        else if (!Incoming[i].To && !strnicmp(Line,"To:",3)) {
            ptr=Line+3;
            while (*ptr==' ') ptr++;
            if (Incoming[i].To=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].To,ptr);
              last_data = &Incoming[i].To;

/* begin -- taken from From: */
              Incoming[i].ToName=NULL;
              if (p=strchr(ptr,'(')) { /* Name wird in '(' eingeschlossen */
                p++;
                if (p!=strchr(ptr,')')) {/* Ausdruck in den Klammern ist nicht leer */
                  if (Incoming[i].ToName=malloc(strlen(p)+1)) {
                    strcpy(Incoming[i].ToName,p);
                    *(strchr(Incoming[i].ToName,')'))='\0';
                  }
                }
              }
              else if (p=strchr(ptr,'<')) { /* Name steht davor */
                if (p!=ptr) {
                  if (*ptr=='\"') ptr++;
                  if (Incoming[i].ToName=malloc(strlen(ptr)+1)) {
                    strcpy(Incoming[i].ToName,ptr);
                    p=strchr(Incoming[i].ToName,'<');
                    do { p--; } while ((p>Incoming[i].ToName) && (*p=='\t' || *p==' ' || *p=='\"'));
                    p++;
                    *p='\0';
                  }
                }
              }
/* end -- taken from From: */

            }
            else
              last_data = NULL;
        }
        else if (!Incoming[i].ReplyTo && !strnicmp(Line,"Reply-To:",9)) {
            ptr=Line+9;
            while (*ptr==' ') ptr++;
            if (Incoming[i].ReplyTo=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].ReplyTo,ptr);
              last_data = &Incoming[i].ReplyTo;
            }
            else
              last_data = NULL;
        }
        else if (!Incoming[i].Subject && !strnicmp(Line,"Subject:",8)) {
            ptr=Line+8;
            while (*ptr==' ') ptr++;
            if (Incoming[i].Subject=malloc(strlen(ptr)+1)) {
              strcpy(Incoming[i].Subject,ptr);
              last_data = &Incoming[i].Subject;
            }
            else
              last_data = NULL;
        }
        else if (!strnicmp(Line,"Priority:",9)) {
            Incoming[i].Urgent = 1;
            last_data = NULL;
        }
        else if (!strnicmp(Line,"X-Status:",9)) {
            ptr=Line+9;
            while (*ptr==' ') ptr++;
            while ((c=*ptr++)!='\0') {
                switch (c) {
                    case 'O' :Incoming[i].Status |= OLD;       break;
                    case 'R' :Incoming[i].Status |= READ;      break;
                    case 'L' :Incoming[i].Status |= LOGGED;    break;
                    case 'A' :Incoming[i].Status |= ANSWERED;  break;
                    case 'F' :Incoming[i].Status |= FORWARDED; break;
                    case 'B' :Incoming[i].Status |= BOUNCED;   break;
                }
            }
            last_data = NULL;
        }
        else if (last_data && strlen(Line) && (Line[0]==' ' || Line[0]=='\t')) {
            ptr=Line;
            while (*ptr==' ' || *ptr=='\t') ptr++;
            *last_data = realloc(*last_data,strlen(ptr)+3+strlen(*last_data));
            strcat(*last_data,"\n ");
            strcat(*last_data,ptr);
        }
        else if (!strlen(Line)) {
          Incoming[i].TextStart=ftell(fp);
          InHeader = FALSE;
          last_data = NULL;
        }
        else
          last_data = NULL;
      }
      else {
        if (!strncmp(Line,"From ",5)) {
          last_data = NULL;
          InHeader = TRUE;
          i=MaxArticle++;
          Incoming[i].SignatureStart=0;
          Incoming[i].ArtikelStart=pos;
          if (i>0) {
            Incoming[i-1].ArtikelEnd=pos-1;
            if (Incoming[i-1].SignatureStart==0)
              Incoming[i-1].SignatureStart=Incoming[i-1].ArtikelEnd;
          }
          Incoming[i].TextStart=pos;
          Incoming[i].TotalLines++;

/*
          sprintf(TBuffer,"\033[%d;1H\033[J\033[%d;1HReading in %s, message: %d",Win_Height,Win_Height,FolderName,MaxArticle);
          outline();
*/
          sprintf(TitleString,"Reading in %s, message: %d",FolderName,MaxArticle);
          SetScreenTitle(TitleString);
        }
        else if (!strcmp(Line,"-- ")) {     /* signature found  */
          Incoming[i].SignatureStart=pos;
          Incoming[i].Lines++;
          Incoming[i].TotalLines++;
        }
        else {
          Incoming[i].Lines++;
          Incoming[i].TotalLines++;
        }
      }
    } /* while (getline)  */

#ifdef DEBUG
      fprintf(stderr," closing act");
#endif

    fseek(fp,0L,2);  /* An das Ende positionieren */
    len=ftell(fp);
    Incoming[i].ArtikelEnd=len-1;
    if (Incoming[i].SignatureStart==0)
      Incoming[i].SignatureStart=Incoming[i].ArtikelEnd;
    CloseHomeBox(fp);

#ifdef DEBUG
      fprintf(stderr," and revert\n");
#endif

    for(i=0;i<(MaxArticle/2);i++) {
      I = Incoming[i];
      Incoming[i] = Incoming[MaxArticle-i-1];
      Incoming[MaxArticle-i-1] = I;
    }

#ifdef DEBUG
    fprintf(stderr," compare old and new message-ids\n");
#endif
    for(i=0;i<MaxArticle;i++) {
      int oi;
      for(oi=0;oi<OldMaxArticle;oi++) {
        if (flgs[oi].MsgID && Incoming[i].MessageID) {
          if (strcmp(flgs[oi].MsgID,Incoming[i].MessageID)==0) {
            Incoming[i].Status = flgs[oi].Stat;
          }
        }
      }
    }

#ifdef DEBUG
      fprintf(stderr," got %d message(s) from folder %s\n",len,FolderName);
#endif
    return(len);
}

BOOL
get_config_entries(void)
{
    FILE *fp;
    char *ptr;
    char line[MAX_LINELENGTH];

    if (!UserName && getenv("UserName")) {
      strcpy(line,getenv("UserName"));
      if (strlen(line)) {
        if (UserName=malloc(strlen(line)+1))
          strcpy(UserName,line);
      }
    }

    if (!(fp=fopen(UULIB_CONFIG,"r"))) {
      fprintf(stderr,"elm: cannot open %s\n",UULIB_CONFIG);
      return(FALSE);
    }

    while(fgets(line,MAX_LINELENGTH-1,fp)) {
        removeCR(line);
        if (!strnicmp(line,"NodeName",8)) {
            ptr=firstnwsp(line);
            if (NodeName=malloc(strlen(ptr)+1))
              strcpy(NodeName,ptr);
        }
        else if (!strnicmp(line,"UserName",8)) {
            ptr=firstnwsp(line);
            if (!UserName)         /* if not already set */
              if (UserName=malloc(strlen(ptr)+1))
                strcpy(UserName,ptr);
        }
        else if (!strnicmp(line,"DomainName",10)) {
            ptr=firstnwsp(line);
            if (DomainName=malloc(strlen(ptr)+1))
              strcpy(DomainName,ptr);
        }
    }
    fclose(fp);

    if (!UserName || !NodeName || !DomainName) {
      fprintf(stderr,"elm: %s incomplete\n",UULIB_CONFIG);
      return FALSE;
    }

    strcpy(line,UULIB);
    strcat(line,UserName);
    strcat(line,ELM_RC);
    if (!(fp=fopen(line,"r"))) {
      strcpy(line,UULIB);
      strcat(line,ELM_RC);
      if (!(fp=fopen(line,"r"))) {
        fprintf(stderr,"elm: cannot open %s\n",ELM_RC);
        return(FALSE);
      }
    }

    while(fgets(line,MAX_LINELENGTH-1,fp)) {
        removeCR(line);
        if (!strnicmp(line,"Screen-Width",12)) {
            ptr=firstnwsp(line);
            Screen_Width = atoi(ptr);
        }
        else if (!strnicmp(line,"Screen-Height",13)) {
            ptr=firstnwsp(line);
            Screen_Height = atoi(ptr);
        }
        else if (!strnicmp(line,"Screen-Interlace",16)) {
            ptr=firstnwsp(line);
            Screen_Interlace = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"AnswerReturnReceipt",19)) {
            ptr=firstnwsp(line);
            ReturnReceipt = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"AnswerReturnView",16)) {
            ptr=firstnwsp(line);
            ReturnView = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"RequestReturnReceipt",20)) {
            ptr=firstnwsp(line);
            WantReturn = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"RequestReturnView",17)) {
            ptr=firstnwsp(line);
            WantView = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"ShowFullHeader",14)) {
            ptr=firstnwsp(line);
            ShowHeader = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"ShowSignature",13)) {
            ptr=firstnwsp(line);
            ShowSig = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"AlwaysKeep",10)) {
            ptr=firstnwsp(line);
            AlwaysKeep = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"AlwaysDelete",12)) {
            ptr=firstnwsp(line);
            AlwaysDelete = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"KeepBackup",10)) {
            ptr=firstnwsp(line);
            KeepBackup = (!strnicmp(ptr,"Yes",3));
        }
        else if (!strnicmp(line,"SendmailVersion",15)) {
            ptr=firstnwsp(line);
            if (!strnicmp(ptr,"Feulner",7))
              SendmailVersion = SM_FEULNER;
            else if (!strnicmp(ptr,"Dillon",6))
              SendmailVersion = SM_DILLON;
            else
              SendmailVersion = SM_OTHER;
        }
        else if (!strnicmp(line,"MaxMails",8)) {
            ptr=firstnwsp(line);
            MaxMails = atoi(ptr);
        }
        else if (!strnicmp(line,"ReceivedFolder",14)) {
            ptr=firstnwsp(line);
            if (strlen(ptr))
              if (ReceivedFolder=malloc(strlen(ptr)+1))
                strcpy(ReceivedFolder,ptr);
        }
        else if (!strnicmp(line,"SentArchive",11)) {
            ptr=firstnwsp(line);
            if (strlen(ptr))
              if (SentArchive=malloc(strlen(ptr)+1))
                strcpy(SentArchive,ptr);
        }
        else if (!strnicmp(line,"Editor",6)) {
            ptr=firstnwsp(line);
            if (MailEditor=malloc(strlen(ptr)+1))
              strcpy(MailEditor,ptr);
        }
        else if (!strnicmp(line,"FullName",8)) {
            ptr=firstnwsp(line);
            if (RealName=malloc(strlen(ptr)+1))
              strcpy(RealName,ptr);
        }
        else if (!strnicmp(line,"ReplyIntroduction",17)) {
            ptr=firstnwsp(line);
            if (ReplyIntro=malloc(strlen(ptr)+1))
              strcpy(ReplyIntro,ptr);
        }
        else if (!strnicmp(line,"ForwardIntroduction",19)) {
            ptr=firstnwsp(line);
            if (ForwardIntro=malloc(strlen(ptr)+1))
              strcpy(ForwardIntro,ptr);
        }
        else if (!strnicmp(line,"PrefixString",12)) {
            ptr=firstnwsp(line);
            PrefixString=malloc(strlen(ptr)+1);
            if (PrefixString) {
              if (*ptr=='\"') {
                strcpy(PrefixString,&ptr[1]);
                PrefixString[strlen(PrefixString)-1]='\0';
              }
              else
                strcpy(PrefixString,ptr);
            }
        }
        else if (!strnicmp(line,"Color",5)) {
            ptr=firstnwsp(line);
            if (ColorData=malloc(strlen(ptr)+1))
              strcpy(ColorData,ptr);
        }
        else if (!strnicmp(line,"Buffers",7)) {
            ptr=firstnwsp(line);
            FileBufferSize = atol(ptr);
            if (FileBufferSize<1024L)
              FileBufferSize = 1024L;
        }
    }
    fclose(fp);

    if (!SendmailVersion || !PrefixString || !RealName || !ReceivedFolder) {
      fprintf(stderr,"elm: %s incomplete\n",ELM_RC);
      return FALSE;
    }

    return TRUE;
}



char *
firstnwsp(char *s)
{
    while(*s!='\0' && *s!=' ' && *s!='\t')
        s++;
    while((*s != '\0') && (*s == ' ' || *s == '\t'))
        s++;
    return s;
}



BOOL
getline(FILE *fp,char *s,long *p)
{
  *p=ftell(fp);
  s[MAX_LINELENGTH-1] = '\n';
  if (fgets(s,MAX_LINELENGTH-1,fp)) {
    *strchr(s,'\n')='\0';
    return(TRUE);
  }
  return(FALSE);
}



void
removeCR(char *s)
{
  if (s=strchr(s,'\n'))
    *s='\0';
}

