
/*
 *  COMPAT.C
 *
 *  (C) Copyright 1985-1990 by Matthew Dillon,  All Rights Reserved.
 */

#include <stdio.h>
#include <pwd.h>
#include <sys/stat.h>
#include "config.h"

#ifdef AMIGA

#include <stdlib.h>
#include <exec/types.h>
#include <libraries/dos.h>
#include <libraries/dosextens.h>

getpid()
{
    return((long)FindTask(NULL));
}

getuid()
{
    return(0);
}

static struct passwd pas;

struct passwd *
getpwuid()
{
    char *name = GetUserName();
    if (name == NULL) {
	puts("Warning, USER enviroment variable not set!");
	name = "root";
    }
    pas.pw_name = malloc(strlen(name) + 1);
    pas.pw_dir	= malloc(16);
    strcpy(pas.pw_name, name);
    strcpy(pas.pw_dir, "sys:");
    return(&pas);
}

void
bzero(d, n)
char *d;
{
    setmem(d, n, 0);
}

void
bcopy(s, d, n)
char *s, *d;
{
    movmem(s, d, n);
}

void
sleep(n)
{
    if (n)
	Delay(50 * n);
}

stat(file, st)
const char *file;
struct stat *st;
{
    struct FileLock *lock;
    struct FileInfoBlock *fib = (struct FileInfoBlock *)malloc(sizeof(struct FileInfoBlock));

    lock = (struct FileLock *)Lock(file, SHARED_LOCK);
    if (lock == NULL)
	return(-1);
    Examine((BPTR)lock, fib);
    lock = (struct FileLock *)((long)lock << 2);
    st->st_ino = lock->fl_Key;
    st->st_ctime = st->st_mtime = fib->fib_Date.ds_Tick / 50 + fib->fib_Date.ds_Minute * 60 + fib->fib_Date.ds_Days * 86400;

    lock = (struct FileLock *)((long)lock >> 2);
    UnLock((BPTR)lock);
    free(fib);
    return(0);
}

flock(fd, locktype)
{
    return(0);
}


#endif

