
/*
 *  COMP.C
 *
 *  compress a file source to a destination file pointer, used by
 *  BATCHNEWS.
 */

#define COMPRESS_ONLY
#define BITS  16	    /*	maximum (dynamically allocate)           */
#define XENIX_16
#include <stdio.h>

#undef stdin
#undef stdout
#define stdin	Fi
#define stdout	Fo

#include <stdlib.h>
#include <string.h>
#include "config.h"

static FILE *Fi;
static FILE *Fo;

#include "/unix/compress.ch"

Prototype int compress_from_file(char *, FILE *, short);
Prototype int compress_from_fp(FILE *, FILE *, short);

int
compress_from_file(inName, fo, bits)
char *inName;
FILE *fo;
short bits;
{
    FILE *fi;
    int r = -1;

    if (bits < 0)                       /*  block compress */
	bits = -bits | BLOCK_MASK;

    if (initcomp(NULL, fo, bits) >= 0) {
	if (fi = fopen(inName, "r")) {
	    Fi = fi;
	    Fo = fo;
	    r = compress();
	    fclose(fi);
	}
    }
    deletecomp();
    return(r);
}

int
compress_from_fp(fi, fo, bits)
FILE *fi;
FILE *fo;
short bits;
{
    int r = -1;

    if (bits < 0)                       /*  block compress */
	bits = -bits | BLOCK_MASK;

    if (initcomp(NULL, fo, bits) >= 0) {
	Fi = fi;
	Fo = fo;
	r = compress();
    }
    deletecomp();
    return(r);
}

