
/*
 *  Amiga specific functions
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <time.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include <clib/dos_protos.h>

extern struct Library *DOSBase;

char *mungename(char *);

char *
index(ptr, c)
char *ptr;
char c;
{
    return(strchr(ptr, c));
}

char *
rindex(ptr, c)
char *ptr;
char c;
{
    return(strrchr(ptr, c));
}

char *
getwd(buf)
char *buf;
{
    return(getcwd(buf, MAXPATHLEN));
}

int
symlink(fileName, linkName)
char *fileName;
char *linkName;
{
    int r = -1;

    if (DOSBase->lib_Version >= 37) {
	if (MakeLink(mungename(linkName), mungename(fileName), 1))
	    r = 0;
    }
    return(r);
}

chmod()
{
    return(0);
}

umask()
{
    return(0);
}

fork()
{
    return(-1);
}

execlp()
{
    return(-1);
}


findgid()
{
    return(0);
}

finduid()
{
    return(0);
}

pipe()
{
    return(-1);
}

dup()
{
    return(-1);
}

wait()
{
    return(-1);
}


int
ftruncate()
{
    return(-1);
}

setmode()
{
    return(0);
}

char *
mungename(name)
char *name;
{
    static char Buf[4][512];
    static short Cnt;
    short i;
    char *buf = Buf[Cnt];

    Cnt = (Cnt + 1) & 3;

    i = 0;

    if (name[0] == '/') {
	buf[i++] = ':';
	++name;
    }

    while (*name) {
	if (strncmp(name, "./", 2) == 0) {
	    name += 2;
	} else if (strncmp(name, "../", 3) == 0) {
	    name += 3;
	    buf[i++] = '/';
	} else {
	    buf[i++] = *name;
	    ++name;
	}
    }
    buf[i] = 0;
    return(buf);
}

