
/*
 *  EXPANDM.C	    expands alias via uulib:Aliases and prints
 *		    results
 *
 *  $Header: Beta:src/uucp/src/MUtil/RCS/expandm.c,v 1.1 90/02/02 12:11:56 dillon Exp Locker: dillon $
 *
 *  (C) Copyright 1989-1990 by Matthew Dillon,  All Rights Reserved.
 *
 *  EXPANDM alias
 */

#include <exec/types.h>
#include <exec/libraries.h>
#include <stdio.h>
#include "config.h"
#include <owndevunit.h>

void myexit(void);

struct Library *OwnDevUnitBase;

main(ac, av)
char *av[];
{
    short i;
    int r;
    void callBack();

    atexit(myexit);

    if ((OwnDevUnitBase = OpenLibrary(ODU_NAME, 0)) == NULL) {
	printf("Unable to open %s\n", ODU_NAME);
	exit(20);
    }

    LoadAliases();
    for (i = 1; i < ac; ++i) {
	printf("%s:\n", av[i]);
	r = UserAliasList(av[i], callBack, 0L, 1);
	printf("r = %d\n", r);
    }
    puts("");
}

void
myexit()
{
    UnLockFiles();

    if (OwnDevUnitBase) {
	CloseLibrary(OwnDevUnitBase);
	OwnDevUnitBase = NULL;
    }
}

void
callBack(name, dummy, show)
char *name;
long dummy;
{
    switch(name[0]) {
    case '|':
	printf(" %-15s (piped to program)\n", name);
	break;
    case '>':
	printf(" %-15s (appended to file)\n", name);
	break;
    case '<':
	printf(" %-15s (further aliases)\n", name);
	break;
    case '\\':
	++name;
    default:
	if (show < 0)
	    printf(" %-15s (on To: field only)\n", name);
	else if (show == 0)
	    printf(" %-15s (not shown on To: field)\n", name);
	else
	    printf(" %-15s (shown on To: field)\n", name);
	break;
    }
}

