/*
 *
 *  AM --- AmigaMail
 *  (C) 1991, 1992 by Christian Riede
 *
 *  AM is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY.  No author or distributor accepts responsibility to anyone
 *  for the consequences of using it or for whether it serves any
 *  particular purpose or works at all, unless he says so in writing.
 *  Refer to the GNU General Public License, Version 1, for full details.
 *  
 *  Everyone is granted permission to copy, modify and redistribute AM,
 *  but only under the conditions described in the GNU General Public
 *  License, Version 1.  A copy of this license is supposed to have been 
 *  given to you along with AM so you can know your rights and responsi-
 *  bilities.  It should be in a file named COPYING.  Among other things,
 *  the copyright notice and this notice must be preserved on all copies.
 *
 *  
 *
 */

#include "am.h"

UBYTE *vers = (UBYTE *)("\0$VER: lmail "AMIGAMAIL_VERSION);

static char MailDirName[160];

char Username[USERLEN+1];


void Panic(void)
{
	FILE *MailFile;
	int i,c;

	/* try up to 20 times with 5s delay */
	i=0;
	while (!(MailFile = fopen("UUMAIL:undeliverable.mail","a")) && i++<20) 
		Delay(250L);

	if (MailFile)
	{
		fprintf(MailFile,"\n\n\nCould't deliver mail for user %s\n\n",Username);
		while ((c=getchar())!=EOF) putc(c,MailFile);
		fclose(MailFile);
	}

	exit(20);

}

/* mail on stdin; username is first or, if present, second parameter */

int main(int argc,char *argv[])
{
	FILE *MailFile;
	int c,seq;
	BPTR MyLock;
	struct Mail *New;

	if (argc==2)
		strcpy(Username,argv[1]);
	else if (argc==3)
		strcpy(Username,argv[2]);
	else
		Panic();

	/* server running? */
	if (!(ServerPort = FindPort(SERVERNAME))) 
		Panic();

	LockContents();

	/* read seq */
	if (!(seq = NewSeq()))
		Panic();

	/* check for directory */
	sprintf(MailDirName,"UUMAIL:%s.mail",Username);
	if (MyLock = Lock((UBYTE *)MailDirName,ACCESS_READ))
		UnLock(MyLock);
	else
	{
		/* create directory */
		if (!(MyLock = CreateDir((UBYTE *)MailDirName)))
			Panic();
		UnLock(MyLock);
	}

	sprintf(MailDirName,"UUMAIL:%s.mail/%ld",Username,seq);
	
	/* open mailfile */
	if (!(MailFile = fopen(MailDirName,"w")))
		Panic();

	/* save the mail */
	while ((c=getchar())!=EOF)
		putc(c,MailFile);

	/* close the mailfile */
	fclose(MailFile);

	/* inform server about new item */
	if (New = AddItem(seq))
		FreeMail(New);
	

	UnLockContents();


	return(0);
}
