/*
 *
 *  AM --- AmigaMail
 *  (C) 1991, 1992 by Christian Riede
 *
 *  AM is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY.  No author or distributor accepts responsibility to anyone
 *  for the consequences of using it or for whether it serves any
 *  particular purpose or works at all, unless he says so in writing.
 *  Refer to the GNU General Public License, Version 1, for full details.
 *  
 *  Everyone is granted permission to copy, modify and redistribute AM,
 *  but only under the conditions described in the GNU General Public
 *  License, Version 1.  A copy of this license is supposed to have been 
 *  given to you along with AM so you can know your rights and responsi-
 *  bilities.  It should be in a file named COPYING.  Among other things,
 *  the copyright notice and this notice must be preserved on all copies.
 *
 *  
 *
 */


#include "am.h"

UBYTE *vers = (UBYTE *)("\0$VER: newmail "AMIGAMAIL_VERSION);

/* check for new mail */

/* usage: newmail <username> */


char Username[160];
char Message[160];

struct Window *Window; /* dummy for os20stuff */

struct IntuitionBase *IntuitionBase;
struct Library *GadToolsBase; /* dummy, library not used */
struct Library *AslBase;      /* dummy, library not used */
struct Library *IconBase=0;

struct List Mailbox;

int main(int argc, char *argv[])
{
	struct Mail *Mail;
#ifdef __GNUC__
	struct WBStartup *WBenchMsg;
#endif
	char *s;
	struct DiskObject *dop;

	/* no workbench start */
	if (argc==0)
	{
		/* when started from sys:wbstartup, possibly the contentsserver isn't already running */
		Delay(250); /* wait 5s */

		if (!(IconBase = 
			OpenLibrary((UBYTE *)"icon.library",AM_LIBRARY_VERSION)))
			exit(5);

#ifdef __GNUC__
		WBenchMsg = (struct WBStartup *)argv;
#endif
		/* try to get Username from ToolTypes */
		if ((dop = GetDiskObject((UBYTE *)WBenchMsg->sm_ArgList->wa_Name)))
		{
			s = (char *) FindToolType((UBYTE **)dop->do_ToolTypes ,(UBYTE *)"USERNAME");
	
			if (s)
				strcpy(Username,s);
			else if (!(getenv("USERNAME")))
				exit(5);
			else
				strcpy(Username,getenv("USERNAME"));
		}
		CloseLibrary(IconBase);
	}
	else if (argc==2)
		strcpy(Username,argv[1]);
	else
	{
		printf("Usage: %s <username>\n",argv[0]);
		exit(5);
	}

	/* open libraries */
	if (!(IntuitionBase = (struct IntuitionBase *)
		OpenLibrary((UBYTE *)"intuition.library",AM_LIBRARY_VERSION)))
	{
		puts("fatal error: can't open intuition.library!!!");
		exit(20);
	}


	if (!(ServerPort = FindPort(SERVERNAME)))
		exit(21);

	LockContents();

	/* init the mailbox-list */
	Mailbox.lh_Head = (struct Node *)&Mailbox.lh_Tail;
	Mailbox.lh_TailPred = (struct Node *)&Mailbox.lh_Head;
	Mailbox.lh_Tail = 0;
	Mailbox.lh_Type = AMNT_MAILBOX;

	/* read in the mailbox */
	GetContents(&Mailbox);

	/* check for new mail */
	for (Mail=(struct Mail *)Mailbox.lh_Head;
		Mail->m_Node.ln_Succ;
		Mail=(struct Mail *)Mail->m_Node.ln_Succ)
		if (!(Mail->read & MAIL_READ))
		{
			/* found unread mail */
			sprintf(Message,"User %s has new mail",Username);
			SimpleRequest(Window,Message);
			break;
		}

	/* free it */
	FreeMailbox(&Mailbox);

	UnLockContents();

	/* close librarie */
	CloseLibrary((struct Library *)IntuitionBase);

	return(0);
}
