/*
 *
 *  AM --- AmigaMail
 *  (C) 1991, 1992 by Christian Riede
 *
 *  AM is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY.  No author or distributor accepts responsibility to anyone
 *  for the consequences of using it or for whether it serves any
 *  particular purpose or works at all, unless he says so in writing.
 *  Refer to the GNU General Public License, Version 1, for full details.
 *  
 *  Everyone is granted permission to copy, modify and redistribute AM,
 *  but only under the conditions described in the GNU General Public
 *  License, Version 1.  A copy of this license is supposed to have been 
 *  given to you along with AM so you can know your rights and responsi-
 *  bilities.  It should be in a file named COPYING.  Among other things,
 *  the copyright notice and this notice must be preserved on all copies.
 *
 *  
 *
 */


#include "am.h"

/* entries in am.config and UULIB:Config*/

char NodeName[MAIL_FIELDLENGTH];
char DomainName[MAIL_FIELDLENGTH];
char MailEditor[MAIL_FIELDLENGTH];
char RFilter[MAIL_FIELDLENGTH];
char AMPubScreen[MAIL_FIELDLENGTH]="\0";
char AMReturnReceiptTo[MAIL_FIELDLENGTH]="Yes";
int AMCTE=2; /* default is 8BIT */
char TimeZone[MAIL_FIELDLENGTH]="GMT";
char ReplyTo[MAIL_FIELDLENGTH]="";
ULONG AMDisplayID;
int LocalHOffset=0;
int LocalMOffset=0;
struct TextAttr AMFont;
UWORD AMColors[5]={4,0x0cb4,0x0000,0x0fff,0x0679}; /* first word is number of colors loaded (max 4)*/
static char FontName[80];
char Signature[MAIL_FIELDLENGTH]="UULIB:.signature";
char AMFlags[MAIL_FIELDLENGTH];

/* read interesting entries in UULIB:Config and in file denoted by s */
void ReadConfig(char *s)
{
	FILE *Config;
	static char InputBuffer[MAIL_FIELDLENGTH];
	static char Name[MAIL_FIELDLENGTH];
	static char Body[MAIL_FIELDLENGTH];
	int YSize,Style,Flags;

	AMFont.ta_Name = (STRPTR) FontName;

	if (!(Config = fopen("UULIB:Config","r")))
		return;

	while (fgets(InputBuffer,MAIL_FIELDLENGTH,Config))
	{
		if (InputBuffer[0]=='#') continue;  /* comment line */
		if (isspace((int)InputBuffer[0])) continue;  /* comment line */
		if (InputBuffer[0]=='\n') continue; /* comment line */

		if (sscanf(InputBuffer,"%s %s",Name,Body)!=2) continue;

		if (!strcmp(Name,"NodeName"))
			strcpy(NodeName,Body);

		else if (!strcmp(Name,"DomainName"))
			strcpy(DomainName,Body);

		else if (!strcmp(Name,"MailEditor"))
			strcpy(MailEditor,Body);

		else if (!strcmp(Name,"RFilter"))
			strcpy(RFilter,Body);

		else if (!strcmp(Name,"AMPubScreen"))
			strcpy(AMPubScreen,Body);

		else if (!strcmp(Name,"AMDisplayID"))
			sscanf(Body,"0x%lx",&AMDisplayID);

		else if (!strcmp(Name,"AMReturnReceiptTo"))
			strcpy(AMReturnReceiptTo,Body);

		else if (!strcmp(Name,"AMCTE"))
			sscanf(Body,"%d",&AMCTE);

		else if (!strcmp(Name,"Signature"))
			strcpy(Signature,Body);

		else if (!strcmp(Name,"TimeZone"))
		{
			strcpy(TimeZone,Body);
			ParseTimeZone(Body,&LocalHOffset,&LocalMOffset);
		}

		else if (!strcmp(Name,"ReplyTo"))
			strcpy(ReplyTo,Body);

		else if (!strcmp(Name,"AMFont"))
		{
			if (sscanf(InputBuffer,"%*s %s %d %d %d",AMFont.ta_Name,&YSize,&Style,&Flags)!=4)
			{
				AMFont.ta_Name = 0;
				AMFont.ta_YSize = 0;
			}
			else
			{
				AMFont.ta_YSize = YSize;
				AMFont.ta_Style = Style;
				AMFont.ta_Flags = Flags;
			}
		}

		else if (!strcmp(Name,"AMFlags"))
			strcpy(AMFlags,Body);
	}

	fclose(Config);

	if (!s) return;

	if (!(Config = fopen(s,"r")))
		return;

	while (fgets(InputBuffer,MAIL_FIELDLENGTH,Config))
	{
		if (InputBuffer[0]=='#') continue;  /* comment line */
		if (InputBuffer[0]==' ') continue;  /* comment line */
		if (InputBuffer[0]=='\n') continue; /* comment line */

		if (sscanf(InputBuffer,"%s %s",Name,Body)!=2) continue;

		if (!strcmp(Name,"MailEditor"))
			strcpy(MailEditor,Body);

		else if (!strcmp(Name,"RFilter"))
			strcpy(RFilter,Body);

		else if (!strcmp(Name,"AMPubScreen"))
			strcpy(AMPubScreen,Body);

		else if (!strcmp(Name,"AMDisplayID"))
			sscanf(Body,"0x%lx",&AMDisplayID);

		else if (!strcmp(Name,"AMReturnReceiptTo"))
			strcpy(AMReturnReceiptTo,Body);

		else if (!strcmp(Name,"AMCTE"))
			sscanf(Body,"%d",&AMCTE);

		else if (!strcmp(Name,"Signature"))
			strcpy(Signature,Body);

		else if (!strcmp(Name,"AMColors"))
			AMColors[0] = sscanf(InputBuffer,"%*s 0x%hx 0x%hx 0x%hx 0x%hx",
				AMColors+1,AMColors+2,AMColors+3,AMColors+4);

		else if (!strcmp(Name,"ReplyTo"))
			strcpy(ReplyTo,Body);

		else if (!strcmp(Name,"AMFont"))
		{
			if (sscanf(InputBuffer,"%*s %s %d %d %d",AMFont.ta_Name,&YSize,&Style,&Flags)!=4)
			{
				AMFont.ta_Name = 0;
				AMFont.ta_YSize = 0;
			}
			else
			{
				AMFont.ta_YSize = YSize;
				AMFont.ta_Style = Style;
				AMFont.ta_Flags = Flags;
			}
		}

	}

	fclose(Config);
}
