/*
 *
 *  AM --- AmigaMail
 *  (C) 1991, 1992 by Christian Riede
 *
 *  AM is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY.  No author or distributor accepts responsibility to anyone
 *  for the consequences of using it or for whether it serves any
 *  particular purpose or works at all, unless he says so in writing.
 *  Refer to the GNU General Public License, Version 1, for full details.
 *  
 *  Everyone is granted permission to copy, modify and redistribute AM,
 *  but only under the conditions described in the GNU General Public
 *  License, Version 1.  A copy of this license is supposed to have been 
 *  given to you along with AM so you can know your rights and responsi-
 *  bilities.  It should be in a file named COPYING.  Among other things,
 *  the copyright notice and this notice must be preserved on all copies.
 *
 *  
 *
 */

#include "am.h"


int ix_exec_entry (int argc, char **argv, char **environ, int *real_errno,
	int (*main)(int, char **, char **));

/* send mail */
/* called via CreateNewProc, reentrant */
#ifdef __GNUC__
static int TheSendMail(int argc,char **argv,char **environ)
#else
void SendMail(int alen,char *arg)
#endif
{
	char MsgId[80];
	char Command[80];
	char archname[80];
	char quotename[80];
	char tmpname[80];
	char encname[80];
	char Date[60];
	ULONG seq;
	FILE *tmp,*sig,*arch,*quotefile,*bin,*enc;
	int c;
	int wascr,header;
	int RRT,CTE;
	struct Mail *NewMail,*MailToReply;
	ULONG Flags;
	char BinaryName[160];
	char To[MAIL_FIELDLENGTH],Cc[MAIL_FIELDLENGTH];
	char Bcc[MAIL_FIELDLENGTH],Subject[MAIL_FIELDLENGTH];
	char Buffer[MAIL_FIELDLENGTH];
	char Buffer1[MAIL_FIELDLENGTH];
	struct stat statbuf;
	long createtime;

#ifdef AZTEC_C
	geta4();
#endif

	running++;

	MailToReply=0;

#ifdef __GNUC__
	if (sscanf(argv[1],"%ld %lx %s",&Flags,(ULONG *)&MailToReply,BinaryName)!=3)
#else
	if (sscanf(arg,"%ld %lx %s",&Flags,(ULONG *)&MailToReply,BinaryName)!=3)
#endif
		goto abort;

	RRT=-1;

	To[0]=Cc[0]=Bcc[0]=Subject[0]=0;

	if (Flags&SFLAGS_REPLY || Flags&SFLAGS_FORWARD)
	{
		if (!MailToReply) goto abort;

		strcpy(To,(*MailToReply->ReplyTo)?
			(MailToReply->ReplyTo):(MailToReply->From));

		/* rewrite address, if necessary (not yet implemented) */

	}

	/* ask for to-address and subject, if not given by original mail */
	if (Flags&SFLAGS_SEND || Flags&SFLAGS_FORWARD)
	{
		if (!GetAddress(To,Cc,Bcc,Subject))
			goto abort; /* no address given */
	}

	/* check for return-receipt-to */		
	RRT = CheckRRT(GetUsername(To,Buffer));
	
	/* determine CTE */
	CTE = CheckCTE(GetUsername(To,Buffer));
		
	if (RRT==-1) 
		RRT = AMReturnReceiptTo[0]=='Y' || AMReturnReceiptTo[0]=='y';

	if (CTE==-1) CTE=AMCTE;

	sprintf(tmpname,"t:%s",NewMsgId(MsgId));

	/* open temp file for write */
	if (!(tmp = fopen(tmpname,"w")))
		goto abort;

	/* generate header */
	fprintf(tmp,"To: %s\n",To);

	/* Check if alternate Reply-To address necessary */
	fprintf(tmp,"Cc: %s\nBcc: %s\nReply-To: %s\n",
		Cc,Bcc,
		GetReplyTo(GetUsername(To,Buffer),Buffer1));

	if (Flags&SFLAGS_REPLY)
		if (!strncmp(MailToReply->Subject,"Re:",3)||
			!strncmp(MailToReply->Subject,"re:",3))
			fprintf(tmp,"Subject: %s\n",MailToReply->Subject);
		else
			fprintf(tmp,"Subject: Re: %s\n",MailToReply->Subject);

	if (Flags&SFLAGS_FORWARD)
		fprintf(tmp,"Subject: %s (Fwd: %s)\n",Subject,MailToReply->Subject);
		
	if (Flags&SFLAGS_SEND)
			fprintf(tmp,"Subject: %s\n",Subject);

	fprintf(tmp,"Date: %s\n",DateTime(0,Date));

	if (!strstr(AMFlags,"DUUCP"))
		fprintf(tmp,"Message-Id: <%s@%s%s>\n",NewMsgId(MsgId),NodeName,DomainName);

	if (Flags&SFLAGS_REPLY)
		if (*MailToReply->MsgId)
			fprintf(tmp,"In-Reply-To: %s\n",MailToReply->MsgId);

	if (RRT)
		if (*ReplyTo)
			fprintf(tmp,"Return-Receipt-To: \"%s\" <%s> \n",Realname,ReplyTo);
		else
			fprintf(tmp,"Return-Receipt-To: %s <%s@%s%s>\n",
				Realname,Username,NodeName,DomainName);

	fprintf(tmp,"X-Mailer: AM %s\n",AMIGAMAIL_VERSION);
/*	fprintf(tmp,"X-Charset: ISO-8859-1\n");*/

	/* MIME-Stuff */
	fprintf(tmp,"MIME-Version: 1.0\n");

	if (Flags&SFLAGS_ILBM)
	{
		fprintf(tmp,"Content-Type: image/x-iff-ilbm\n");
		CTE=0; /* ILBMs always in BASE64 encoding */
	}
	else if (Flags&SFLAGS_GIF)
	{
		fprintf(tmp,"Content-Type: image/gif\n");
		CTE=0; /* GIFs always in BASE64 encoding */
	}
	else
		fprintf(tmp,"Content-Type: text/plain;charset=ISO-8859-1\n");

	fprintf(tmp,"Content-Transfer-Encoding: %s\n",ContentTransferEncoding[CTE]);

	/* end of header, insert blank line */
	putc('\n',tmp);

	/* include binary data */
	if (Flags&(SFLAGS_ILBM|SFLAGS_GIF))
	{
		if (!(bin = fopen(BinaryName,"r")))
		{
			SimpleRequest(Window,"Can't open binary file");
			fclose(tmp);
			DeleteFile((UBYTE *)tmpname);
			goto abort;
		}
		
		/* copy */
		while ((c=getc(bin))!=EOF) putc(c,tmp);

		fclose(bin);
	}
	

	/* quote, if requested */
	if (Flags&SFLAGS_REPLY && Flags&SFLAGS_QUOTE)
	{
		/* open file */
		sprintf(quotename,"uumail:%s.mail/%ld",Username,MailToReply->Number);
		if ((quotefile = fopen(quotename,"r")))
		{
			fprintf(tmp,"In your letter from %s you wrote:\n\n> ",
				DateTime(MailToReply->Date,Buffer));
			header = !(Flags&SFLAGS_HEADER); /* include header ? */
			wascr = FALSE;
			while ((c=getc(quotefile))!=EOF)
			{
				if (!header)
				{
					putc(c,tmp);
					if (c=='\n') 
					{
						putc('>',tmp); 
						putc(' ',tmp);
					}
				}
				else
				{
					if (wascr) if (c=='\n') 
					{
						header = FALSE; 
						putc('\n',tmp); 
						putc('>',tmp); 
						putc(' ',tmp);
					}								
					wascr = (c=='\n');
				}
			}
			fclose(quotefile);
		}
	}

	/* include forwarded mail if requested */
	if (Flags&SFLAGS_FORWARD)
	{
		fprintf(tmp,"The following mail has been forwarded to you by %s:\n\n",Realname);
		fprintf(tmp,"------------ beginning of forwarded mail -------------\n");

		/* open file */
		sprintf(quotename,"uumail:%s.mail/%ld",Username,MailToReply->Number);
		if ((quotefile = fopen(quotename,"r")))
		{
			header = !(Flags&SFLAGS_HEADER);  /* include header ? */
			if (header)
				putc('>',tmp); 
			wascr = FALSE;
			while ((c=getc(quotefile))!=EOF)
			{
				if (!header)
					putc(c,tmp);
				else
					if (wascr) if (c=='\n') 
						header = FALSE; 
				wascr = (c=='\n');
			}
		}
		fprintf(tmp,"------------ end of forwarded mail -------------\n");
	}

	/* if not binary then append signature */
	if (!(Flags&SFLAGS_ILBM))
		if(sig = fopen(Signature,"r"))
		{
			while ((c=getc(sig))!=EOF)
				putc(c,tmp);
			fclose(sig);
		}

	/* close tmpfile */
	fclose(tmp);

	/* remember time of last modification */
	if (stat(tmpname,&statbuf)>=0) createtime = statbuf.st_mtime;
	else
	{
		SimpleRequest(Window,"Can't stat");
		DeleteFile((UBYTE *)tmpname);
		goto abort;
	}

	/* let user edit file, if not binary */
	if (!(Flags&(SFLAGS_ILBM|SFLAGS_GIF)))
	{
		if (*MailEditor)
		{
			sprintf(Command,"%s %s",MailEditor,tmpname);
			System((UBYTE *)Command,AMSystemTags);
		}
		else
		{
			SimpleRequest(Window,"No Mail Editor Set");
			goto abort;
		}
	}

	/* check if file was modified */
	if ((Flags&(SFLAGS_SEND|SFLAGS_REPLY)) && (!(Flags&(SFLAGS_ILBM|SFLAGS_GIF))))
	{
		if (stat(tmpname,&statbuf)<0)
		{
			SimpleRequest(Window,"Bad file, send aborted!");
			goto abort;
		}
		else if (statbuf.st_mtime == createtime)
		{
			SimpleRequest(Window,"File not modified, send aborted!");
			goto abort;
		}
	}

	/* encode mail */
	if (CTE==0 || CTE==1) /* 0=BASE64, 1=QP */
	{
		sprintf(encname,"t:%s",NewMsgId(MsgId));

		if (!(enc = fopen(encname,"w")))
		{
			SimpleRequest(Window,"Can't create encode file");
			goto abort;
		}

		if (!(tmp = fopen(tmpname,"r")))
		{
			SimpleRequest(Window,"Can't open tmp file");
			fclose(enc);
			goto abort;
		}

		/* copy header */
		header = TRUE; wascr=TRUE;
		while (header)
		{
			c=getc(tmp);
			if (c=='\n') 
			{
				if (wascr) header = FALSE;
				else wascr = TRUE;
			}
			else wascr = FALSE;
			putc(c,enc);
		}

		if (CTE==0)	to64(tmp,enc);		
		else toqp(tmp,enc);

		fclose(tmp);
		fclose(enc);
		DeleteFile((UBYTE *)tmpname);
		strcpy(tmpname,encname);
	}

	/* determine size of mail */
	stat(tmpname,&statbuf);

	/* confirm send */
	if (TwoGadRequest(Window,
		"This Mail contains %ld Characters,\n   send ?   ",
		(ULONG)statbuf.st_size))
	{
		/* sendmail */
		if (strstr(AMFlags,"DUUCP"))
			sprintf(Command,"%s <%s -f %s -R \"%s\"",SENDMAIL,tmpname,Username,Realname);
		else
			sprintf(Command,"%s <%s -f \"%s <%s@%s%s>\"",SENDMAIL,tmpname,
				Realname,Username,NodeName,DomainName);

		System((UBYTE *)Command,AMSystemTags);

		/* archive mail, */

		/* get seq */
		seq = NewSeq();

		sprintf(archname,"uumail:%s.mail/%ld",Username,seq);

		if (!(arch = fopen(archname,"w")))
			goto abort;

		fprintf(arch,"From %s (ARCHIVE)\n",Username);
		fprintf(arch,"From: %s <%s@%s%s>\n",
			Realname,Username,NodeName,DomainName);
		
		/* copy tmpfile */
		if (!(tmp = fopen(tmpname,"r")))
			goto abort;

		while ((c=getc(tmp))!=EOF) putc(c,arch);

		fclose(tmp);

		fclose(arch);

		/* delete tmpfile */
		DeleteFile((UBYTE *)tmpname);

		/* AM will be notified seperately */
		if (NewMail = AddItem(seq))
			FreeMail(NewMail);

		/* delete tmpfile */
		DeleteFile((UBYTE *)tmpname);
	}

	/* that's it */

abort:

	running--;

#ifdef __GNUC__
	return(0);
#else
	return;
#endif
}


#ifdef __GNUC__
void SendMail(void)
{
	register char *arg __asm__ ("a0");
	char *thearg;
	char *argv[2];
	void *ixb;

	thearg = arg; /* a0 is scratch register */

	if (!(ixb  = OpenLibrary ((UBYTE *)"ixemul.library", IX_VERSION)))
		return;

	argv[0] = "AM_SendMail";
	argv[1] = thearg;

	ix_exec_entry(2,argv,0,0,TheSendMail);

	CloseLibrary(ixb);
}
#endif

